#!/usr/bin/perl
package SarkSubs;
use DBI;
use CGI ':all';
use Net::Domain qw(hostname hostfqdn hostdomain);
use IO::Socket::INET;

my $maxundonum = '5';


sub check_pid {
    if ( -e "/persistent" ) {
    	unless  (`/bin/ps -e | /bin/grep '/bin/asterisk' | /bin/grep -v grep`) {
    		return ();
    	}
    }
    else {
    	unless  (`/bin/ps -e | /bin/grep asterisk | /bin/grep -v grep`) {
    		return();
    	}
    }
#   return (-1);
}

sub check_hapid {
    unless  (`/bin/ps -e | /bin/grep heartbeat | /bin/grep -v grep`) {
    	return();
    }
   return (-1);
}

sub check_hapid_installed {
    unless  ( -e "/usr/lib/heartbeat/heartbeat" ) {
    	return();
    }
   return (-1);
}

sub sark_header($) {

    my ($q) = shift;
    print $q->header (-EXPIRES => '-1y', charset => 'UTF-8');

    print<<"HEADER";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<head>
<title>SARK PBX</title>
<meta name="copyright" content="Copyright 2005-2011 CoCoSoft" />
<link rel="stylesheet" type="text/css" href="/sark-common/css/sark.css" />
<link rel="stylesheet" type="text/css" href="/sark-common/js/jquery.fancybox-1.3.3/fancybox/jquery.fancybox-1.3.3.css" />
<link rel="stylesheet" type="text/css" href="/sark-common/js/jquery-ui/development-bundle/themes/custom-theme/jquery.ui.all.css" media="screen" />
<script type="text/javascript">//<![CDATA[
function confirmOK(myMsg) {
    					   return window.confirm(myMsg);
					   }
//]]></script>
<script type="text/javascript" src="/sark-common/js/jquery-ui/js/jquery-1.4.2.min.js" type="text/javascript"></script>
<script type="text/javascript" src="/sark-common/js/jquery.fancybox-1.3.3/fancybox/jquery.fancybox-1.3.3.pack.js"></script>
<script type="text/javascript" src="/sark-common/js/jquery.fancybox-1.3.3/fancybox/jquery.easing-1.3.pack.js"></script>
<script type="text/javascript" src="/sark-common/js/jquery.fancybox-1.3.3/fancybox/jquery.mousewheel-3.0.4.pack.js"></script>
<script type="text/javascript" src="/sark-common/js/jquery-ui/js/jquery-ui-1.8.6.custom.min.js"></script>
<script type="text/javascript" src="/sark-common/js/custom.js" type="text/javascript"></script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</head>
<body>
HEADER

   print $q->start_form (-method => 'POST',
                         -action => $q->url (-absolute => 1));
   return();
}

sub sark_error($) {
    my $Verror = shift;
    print "<strong>";
    foreach (@{$Verror}) {
    	print span ({-style=>'Color: red; font-size:150%;'},"$_<br/>");
    }
    print "</strong>";
    print "<br/>";
    return();
}

sub sark_footer($) {

    my ($q) = shift;


#   throw a line because IE puts stuff alongside the buttons if you don't.
    print $q->br;

    print '<hr class="hr" />';
    print span ({-style=>'font-size:x-small; color:#cccccc'},"Copyright CoCoSoft 2008-2010. All rights reserved.");
#    print '<p>';
#    print '<a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" height="31" width="88" /></a>';
#    print '</p>';
    print $q->end_form;
    print $q->end_html;
    return();
}

#
#   Buttons - all generated here
#

sub sark_button_adopt() {
    print image_button(-name=>'adopt',
				-src=>'/sark-common/buttons/V1_0042_ADAPT-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0029_ADAPT-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0042_ADAPT-ON.png';",
                                -alt=>'Adopt',
                                -title=>'Scan the local network for phones to adopt',
				);
    return 0;
}

sub sark_button_cancel() {
    print image_button(-name=>'cancel',
				-src=>'/sark-common/buttons/V1_0040_CANCEL-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0038_CANCEL-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0040_CANCEL-ON.png';",
                                -alt=>'Cancel',
                                -title=>'Cancel & Return',
				);
    return 0;
}

sub sark_button_cfwd() {
    print image_button(-name=>'cfwd',
				-src=>'/sark-common/buttons/V1_0048_CF-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0035_CF-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0048_CF-ON.png';",
                                -alt=>'Cancel',
                                -title=>'Fetch live call-forward info from Asterisk',
				);
    return 0;
}

sub sark_button_commit($$) {
    my $commit_type = shift || 'initcommit';
    my $commit_state = shift || 'NO';
    unless ($commit_state eq "YES") {
    	print image_button(-name=>"$commit_type",
				-src=>'/sark-common/buttons/V1_0051_COMMIT-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px; ',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0039_COMMIT-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0051_COMMIT-ON.png';",
                                -alt=>'Commit',
                                -title=>'COMMIT (Generate Asterisk objects)',
                                -onClick => "return confirmOK('Commit - Confirm?')",
				);
    }
    else {
        print image_button(-name=>"$commit_type",
				-src=>'/sark-common/buttons/V1_0027_COMMIT-CLICK.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0039_COMMIT-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0027_COMMIT-CLICK.png';",
                                -alt=>'Commit',
                                -title=>'COMMIT (You currently have uncommitted changes)',
                                -onClick => "return confirmOK('Commit - Confirm?')",
				);
    }

    return 0;
}

sub sark_button_delete($) {
    my $delete_type = shift || 'delete';
    print image_button(-name=>"$delete_type",
				-src=>'/sark-common/buttons/V1_0043_DELETE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0031_DELETE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0043_DELETE-ON.png';",
                                -alt=>'Delete',
                                -title=>'Delete this object',
                                -onClick => "return confirmOK('Delete - Confirm?')",
				);
    return 0;
}

sub sark_button_ha_start() {
   print image_button(-name=>'ha_start',
				-src=>'/sark-common/buttons/V1_0011_HA-START-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0010_HA-START-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0011_HA-START-ON.png';",
                                -alt=>'Start',
				-title=>'START the HA engine',
                                -onClick => "return confirmOK('START the HA engine - Confirm?')",
				);
    return 0;
}

sub sark_button_ha_stop() {
    print image_button(-name=>'ha_stop',
     				-src=>'/sark-common/buttons/V1_0004_HA-STOP-ON.png',
                                -style=>'border-style: none;  margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0005_HA-STOP-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0004_HA-STOP-ON.png';",
                                -alt=>'Stop',
                                -title=>'STOP the HA engine',
#                                -value => 'Stop',
                                -onClick => "return confirmOK('STOP the HA engine - Confirm?')",
				);
    return 0;
}

sub sark_button_initialize() {
    print image_button(-name=>'initialize',
				-src=>'/sark-common/buttons/V1_0041_RESOLVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0028_RESOLVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0041_RESOLVE-ON.png';",
                                -alt=>'Resolve',
                                -title=>'Initialize & Regenerate the PCI card settings',
                                -onClick => "return confirmOK('Regenerate - Confirm?')",
				);
    return 0;
}

sub sark_button_new() {
    print image_button(-name=>'new',
	    #			-id=>"mySave",
                                -src=>'/sark-common/buttons/V1_0045_NEW-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0030_NEW-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0045_NEW-ON.png';",
                                -alt=>'New',
                                -title=>'Create a new object',
				);
    return 0;
}

sub sark_button_ok($) {
    my $button_name = shift || 'ok';
    print image_button(-name=>"$button_name",
				-src=>'/sark-common/buttons/V1_0050_NEXT-ON-.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0037_NEXT-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0050_NEXT-ON-.png';",
                                -alt=>'OK',
                                -title=>'Continue',
				);

    return 0;
}
#
#  ReGen not used - used to be part of PCI
#
sub sark_button_regen() {
    print image_button(-name=>'regen',
				-src=>'/sark-common/buttons/V1_0042_ADAPT-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0029_ADAPT-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0042_ADAPT-ON.png';",
                                -alt=>'ReGen',
                                -title=>'Regenerate Asterisk PCI card definitions',
                                -onClick => "return confirmOK('ReGen - Confirm?')",
				);
    return 0;
}
#
#  Resolve is used to restart the  firewall in 3.1+
#
sub sark_button_resolve() {
    print image_button(-name=>'resolve',
				-src=>'/sark-common/buttons/V1_0041_RESOLVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0028_RESOLVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0041_RESOLVE-ON.png';",
                                -alt=>'Restart',
                                -title=>'Restart the Firewall',
                                -onClick => "return confirmOK('Restart the Firewall - Confirm?')",
				);
    return 0;
}

sub sark_button_reboot() {
    print image_button(-name=>'reboot',
				-src=>'/sark-common/buttons/V1_0041_RESOLVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0028_RESOLVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0041_RESOLVE-ON.png';",
                                -alt=>'Reboot',
                                -title=>'Reboot',
                                -onClick => "return confirmOK('Reboot - Confirm?')",
				);
    return 0;
}

sub sark_button_save($) {
    my $button_name = shift || 'save';
    print image_button(-name=>$button_name,
	    #			-id=>"mySave",
                                -src=>'/sark-common/buttons/V1_0049_SAVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0036_SAVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0049_SAVE-ON.png';",
                                -alt=>'Save and Continue',
                                -title=>'Save & Continue',
				);
    return 0;
}

sub sark_button_saveDiD() {
    my $button_name = 'save';
    print image_button(-name=>$button_name,
	    #			-id=>"mySave",
                                -src=>'/sark-common/buttons/V1_0049_SAVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0036_SAVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0049_SAVE-ON.png';",
                                -alt=>'Save and Continue',
                                -title=>'Save & Continue',
                                -onClick => "return confirmOK('Last chance to check the number of DiDs you are about to create...')",
				);
    return 0;
}

sub sark_button_saveUSB($) {
    my $button_name = shift || 'save';
    print image_button(-name=>$button_name,
	    #			-id=>"mySave",
                                -src=>'/sark-common/buttons/V1_0049_SAVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0036_SAVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0049_SAVE-ON.png';",
                                -alt=>'Save the backups and snaps to the USB drive',
                                -title=>'Save the backups and snaps to the USB drive',
				);
    return 0;
}


#
#  Spin is used tocreate a regression in  3.1+
#
sub sark_button_spin() {
    print image_button(-name=>'spin',
				-src=>'/sark-common/buttons/V1_0041_RESOLVE-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0028_RESOLVE-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0041_RESOLVE-ON.png';",
                                -alt=>'Restart',
                                -title=>'Instant Backup',
                                -onClick => "return confirmOK('Create an instant backup - Confirm?')",
				);
    return 0;
}

sub sark_button_start() {
   print image_button(-name=>'start',
				-src=>'/sark-common/buttons/V1_0014_PLAY-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0013_PLAY-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0014_PLAY-ON.png';",
                                -alt=>'Start',
				-title=>'START the PBX',
                                -onClick => "return confirmOK('Start the PBX - Confirm?')",
				);
    return 0;
}

sub sark_button_stop() {
    print image_button(-name=>'stop',
     				-src=>'/sark-common/buttons/V1_0007_STOP-ON.png',
                                -style=>'border-style: none;  margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0008_STOP-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0007_STOP-ON.png';",
                                -alt=>'Stop',
                                -title=>'STOP the PBX',
#                                -value => 'Stop',
                                -onClick => "return confirmOK('Stop the PBX - Confirm?')",
				);
    return 0;
}

sub sark_button_undo() {
    print image_button(-name=>'undo',
				-src=>'/sark-common/buttons/V1_0046_UNDO-ON.png',
                                -style=>'border-style: none; margin: 4px 2px 4px 2px;',
                                -onmouseover=>"javascript:this.src='/sark-common/buttons/V1_0033_UNDO-ROLLOVER.png';",
                                -onmouseout=>"javascript:this.src='/sark-common/buttons/V1_0046_UNDO-ON.png';",
                                -alt=>'Undo',
                                -title=>'UNDO',
				);
    return 0;
}

#
#  Buttons END
#


sub sark_password () {

    my @alphanumeric = ('a'..'z', 'A'..'Z', 0..9);
    my $randpassword = join '', map $alphanumeric[rand @alphanumeric], 0..7;
    return ($randpassword);
}

sub sark_stop () {
    my $ret;
    if ( -e "/persistent" ) {
    	$ret = (request_syscmd ('/bin/asterisk -rx "stop now"'));
    	$ret = 'Asterisk STOP issued';
    }
    else {  
    	`/bin/touch /opt/sark/passwd/.stop`;
	$ret = "stop signal sent - PBX will stop in about 1 minute";
    }
    return($ret);
}

sub sark_start () {
    my $ret;
    if ( -e "/persistent" ) {
       $ret = (request_syscmd ("/persistent/autorun/S98asterisk"));
       $ret = "Asterisk START issued";
    }
    else { 
	`/bin/touch /opt/sark/passwd/.start`;
	$ret = "start signal sent - PBX will start in about 1 minute";           
    }
    return($ret);
}

sub request_syscmd ($) {

	my $data = shift || return (-1);
	my ($socket,$client_socket);
# creating object interface of IO::Socket::INET modules which internally creates
# socket, binds and connects to the TCP server running on the specific port.
	$socket = new IO::Socket::INET (
		PeerHost => '127.0.0.1',
		PeerPort => '7601',
		Proto => 'tcp',
	) or die "ERROR in Socket Creation : $!\n";

#	$socket->autoflush(1);
#	print "TCP Connection Success.\n";

# read the socket data sent by server.
	my $ack = <$socket>;
        my $ret;
# we can also read from socket through recv()  in IO::Socket::INET
# $socket->recv($data,1024);
#	print "Received from Server : $ack\n";
#	print "sending $data\n";
#
# write on the socket to server.
#$data = "/etc/init.d/sark stop";
	print $socket "$data\n";
# we can also send the data through IO::Socket::INET module,
# $socket->send($data);

while (	! /<<EOT>>/ ) {
 	$_ = <$socket>;
	unless (  /<<EOT>>/ ) {
        	$ret .= $_;
	}
#	print STDERR "$_";
}
$socket->close();
return ($ret);

}

sub sark_standby () {

    `/usr/lib/heartbeat/hb_standby`;
    return ();
}


sub get_rec_list () {
    my @Reclist;
    if ( !-e "/opt/sark/recone") {
    	@Reclist = qw /default None OTR/;
    	return (@Reclist);
    }
    @Reclist = qw /default None OTR OTRR/;
    return (@Reclist);
}


sub routeClass($) {
	my ($var) = shift;
#
# This little sub returns a "routeclass" for the open/closed/outcome value you input
# The routeclass makes life a lot easier for the AGI when it has
# to route a call through the open/closed/outcome vectors
#
# 0  => value is "None" for an IVR menu selection
# 1  => value is a dialable internal number (extension or callgroup)
# 2  => value is an IVR name
# 3  => value is the default IVR
# 4  => value is a queue name
# 5  => value is DISA
# 6  => value is CALLBACK
# 7  => Not Used
# 8  => value is a sibling
# 9  => value is a trunk name
# 10 => value is a custom_app name
# 11 => value is a trunk group
# 20 => value is Retrieve Voicemail
# 21 => value is Leave Voicemail
#100 => value is Operator
#101 => value is Hangup
#

        if ($var eq "None") {
        	return (0);
        }
        if ($var =~ /^\*\d{3,4}$/) {
        	return (1);
        }
        if ($var =~ /^\d{3,4}$/) {
        	return (1);
        }

        if ($var eq "Default IVR") {
        	return (3);
        }
        if ($var eq "DISA") {
        	return (5);
        }
        if ($var eq "CALLBACK") {
        	return (6);
        }
        if ($var eq "Retrieve Voicemail") {
        	return (20);
        }
        if ($var eq "Leave Voicemail") {
        	return (21);
        }
        if ($var eq "Operator") {
        	return (100);
        }
        if ($var eq "Hangup") {
        	return (101);
        }
        my $ret = 0;
        my $dbh = SQLiteConnect();
        if (SQLiteGet($dbh, "SELECT pkey FROM lineIO where pkey = '$var'")) {
        	my $carrier = SQLiteGet($dbh, "SELECT carrier FROM lineIO where pkey = '$var'");
                my $type = SQLiteGet($dbh, "SELECT carriertype FROM Carrier where pkey = '$carrier'");
                if ($type eq 'group') {
                        $ret = 11;
                }
                else {
        		if ($var =~ /~/) {
                		$ret = 8;
                	}
                	else {
                      		$ret = 9;
                	}
                }
        }
        elsif (SQLiteGet($dbh, "SELECT pkey FROM speed where pkey = '$var'")) {                    
                $ret = 1;                                                                          
        } 
        elsif (SQLiteGet($dbh, "SELECT pkey FROM Queue where pkey = '$var'")) {
        	$ret = 4;
        }
        elsif (SQLiteGet($dbh, "SELECT pkey FROM ivrmenu where pkey = '$var'")) {
        	$ret = 2;
        }
        elsif (SQLiteGet($dbh, "SELECT pkey FROM Appl where pkey = '$var'")) {
        	$ret = 10;
        }
        SQLiteDisconnect($dbh);
        return ($ret);
}

sub aLabelFor($) {
	my ($label) = shift;

        my $ret = "<p><label><a href=\"#\" id=\"hd$label\" class=\"tt\" style=\"color:#000000; padding-top: 10px;\">";
        $ret .= tt_display($label);
        $ret .= '<span class="tooltip"><span class="top"></span><span class="middle">';
        $ret .= tt_text($label);
        $ret .= '</span><span class="bottom"></span></span></a></label>';

        return $ret;
}

sub aHeaderFor($) {
	my ($label) = shift;

        my $ret = '<a href="#" class="tt" style="color:#ffffff">';
        $ret .= tt_display($label);
        $ret .= '<span class="tooltip"><span class="top"></span><span class="middle">';
        $ret .= tt_text($label);
        $ret .= '</span><span class="bottom"></span></span></a>';

        return $ret;
}

sub tt_text ($) {

    my ($key) = shift;
    my $data ;
    my $dbh = SQLiteConnect();
    $data .= SQLiteGet($dbh, "SELECT htext FROM tt_help_user where pkey = '".$key."'" ) ||
                SQLiteGet($dbh, "SELECT htext FROM tt_help_core where pkey = '".$key."'" ) ||
                SQLiteGet($dbh, "SELECT htext FROM tt_help_core where pkey = 'nohelp'" );
    SQLiteDisconnect($dbh);
    $data .= '<br/><br/>SysName: '.$key.'<br/>';

    return ($data);
}

sub tt_display ($) {

    my ($key) = shift;
    if ($key eq 'Sarksystemh11') {
		my $data = hostname();
		return (  uc "$data - " );
    }
    my $dbh = SQLiteConnect();
    my $data = SQLiteGet($dbh, "SELECT displayname FROM tt_help_user where pkey = '".$key."'" ) ||
                SQLiteGet($dbh, "SELECT displayname FROM tt_help_core where pkey = '".$key."'" ) ||
                SQLiteGet($dbh, "SELECT displayname FROM tt_help_core where pkey = 'nohelp'" );
    SQLiteDisconnect($dbh);
    return ($data);
}

sub ret_localip () {
    $_ = `/sbin/ifconfig eth0`;
    /inet addr:*?([\d.]+)/;
    return ($1);
}
sub ret_subnet () {
    	my $ipaddr = ret_localip();
    	my $nmask = ret_subnetmask();
    	my @addrarr=split(/\./,$ipaddr);
 	my ( $ipaddress ) = unpack( "N", pack( "C4",@addrarr ) );
	my @maskarr=split(/\./,$nmask);
	my ( $netmask ) = unpack( "N", pack( "C4",@maskarr ) );

# Calculate network address by logical AND operation of addr & netmask
# and convert network address to IP address format
	my $netadd = ( $ipaddress & $netmask );
	my @netarr=unpack( "C4", pack( "N",$netadd ) );
	my $netaddress=join(".",@netarr);

	return ($netaddress);
}



sub ret_subnetmask () {
    $_ = `/sbin/ifconfig eth0`;
    /Mask:*?([\d\.]+)/;
    return ($1);
}

sub ret_cidr () {
    my $numbits = 0;
    my $nmask = ret_subnetmask ();
    $nmask =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})/;
    push (my @nums, $1, $2, $3, $4 );
    foreach ( @nums ) {
	if ( /255/ ) {
		$numbits+=8;
	}
	elsif ( /254/ ) {
		$numbits+=7;
	}
	elsif ( /252/ ) {
		$numbits+=6;
	}
	elsif ( /248/ ) {
		$numbits+=5;
	}
	elsif ( /240/ ) {
		$numbits+=4;
	}
	elsif ( /224/ ) {
		$numbits+=3;
	}
	elsif ( /192/ ) {
		$numbits+=2;
	}
	elsif ( /128/ ) {
		$numbits+=1;
	}
    }
    return ($numbits);
}

#sub ret_buildpath () {
#
#    return ("/etc/asterisk/");
#}

sub sysCommit($) {
#    print STDERR "IN sysCommit\n";
    my ($q) = shift;

#   simple serialization
#    my $expire = 0;
#   while ( -e  '/opt/sark/db/sark.lock' ) {
#        print STDERR "Couldn't get Commit lock - Retrying in 1 second\n";
#    	sleep 1;
#        $expire++;
#        if ($expire > 10) {
#        	die "Commit processor locked";
#        }
#    }
#    `/bin/touch /opt/sark/db/sark.lock`;

# ask the helper to run a regen/reload for us.

    $rc = request_syscmd ("/bin/sh /opt/sark/scripts/srkgenAst >/dev/null 2>&1");
    $rc = request_syscmd ("/bin/sh /opt/sark/scripts/srkreload >/dev/null 2>&1");
  
 
    my $dbh =SQLiteConnect();
# turn off commit
    SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='NO' WHERE pkey='global'");
# clear undologs
#    SQLiteDo($dbh,"DELETE FROM undolog");
# generate FOP layouts if requested
	if (SQLiteGetGlobal($dbh,"RUNFOP") eq 'enabled') {
		$rc = request_syscmd ("perl /opt/sark/scripts/op_buttons.pl >/dev/null 2>&1");
		$rc = request_syscmd ("perl /opt/sark/scripts/name_op_buttons.pl >/dev/null 2>&1");	
	}
# we're out
    SQLiteCommit($dbh);
    SQLiteDisconnect($dbh);
    my $cmd = "/bin/sh /opt/sark/scripts/snap.sh";
    request_syscmd ( $cmd );
    my @Snapshots = `/bin/ls -trd /opt/sark/snap/*`;
    my $ss = scalar @Snapshots;
    if ($ss > 5 ) {
    	my $deletions = $ss - 5;
    	while ($deletions) {
    		my $deletefile = shift(@Snapshots);
        	$cmd = "/bin/rm $deletefile";
        	request_syscmd ( $cmd );
    		$deletions--;
        }
    }
    unlink '/opt/sark/db/sark.lock';
}

sub validateTuple ($$$$$$) {
#
#   Iterate over the screen variables and validate any variable which has
#   a match in the DB record hash.  Validate by processing against a hash
#   of REGEX flagging any errors into the error hashes.
#
    my ($hashScrnVarRef,
    	$hashRecordRef,
   	$hashVarRegexRef,
        $hashOutBufRef,
        $hashColorDefaultRef,
        $VerrorRef
        ) = @_;
    while ( my ($key, $value) = each %{$hashScrnVarRef} ) {
    	if (exists $hashRecordRef->{$key} ) {
        	unless ($value eq $hashRecordRef->{$key} ) {
                	if ( exists $hashVarRegexRef->{$key} ) {
                                $value =~ s/^\s+//;
                		$value =~ s/\s$//;
                		$value =~  $hashVarRegexRef->{$key} ;
                                if ( $1 eq $value ) {
#	                              	print STDERR "DOLLAR 1 is $1\n";
									$hashOutBufRef->{$key} = $1;
                                }
                                else {
                                	push ( @{$VerrorRef}, "$key Failed validation with $value");
                                        $hashColorDefaultRef->{$key} = 'red';
                                        $hashVarErrorRef->{$key} = 1;
                                        $gonogo = 1;
#                                        print STDERR "DOLLAR 1 IS $1 \n";
#                                        print STDERR "SET GONOGO \n";
                                }
                        }
                        else {
                        	$value =~ $hashVarRegexRef->{"AADEFAULT"} ;
                                if ( $1 eq $value ) {
#                              	print STDERR "DOLLAR 1 is $1\n";
        			 	$hashOutBufRef->{$key} = $1;
                                }
                                else {
                                	push (@{$VerrorRef}, "$key Failed Standard validation with $value");
                                        $hashColorDefaultRef->{$key} = 'red';
                                        $hashVarErrorRef->{$key} = 2;
                                        $gonogo = 1;
#                                        print STDERR "SET GONOGO \n";
                                }
                        }
                }
        }
    }
    unless ( $hashScrnVarRef->{pkey} ) {
    	push (@{$VerrorRef}, "No KEY Entered");
        $hashColorDefaultRef->{"pkey"} = 'red';
    	$gonogo = 1;
    }
    return ($gonogo);
}

sub newTuple ($$$) {
#        print STDERR "BEGININSERT\n";
	my ($hashVarOutBufRef, $table, $dbh) = @_;
	my $inserts = "(";
	my $newvalue = "(";

   	while ( my ($k, $v) =  each %{$hashVarOutBufRef} ) {
    		if ($v) {
    			$inserts .= "$k,";
			$newvalue .= "'$v',";
        	}
        }
#        unless (SQLiteGetGlobal($dbh,"UNDOONOFF") eq 'ON') {
#		SQLiteDo($dbh, "INSERT INTO undolog VALUES(NULL,'BEGINTRANS')");
#    		SQLiteSetUndoTrigger($dbh,$table);
#        }
    	my $sqlstmt = "INSERT INTO $table ".$inserts;
    	$sqlstmt =~ s/,$/) VALUES $newvalue/;
    	$sqlstmt =~ s/,$/)\;/;
#        print STDERR "SQL STATEMENT IS \n $sqlstmt \n";
    	SQLiteDo($dbh, $sqlstmt);
    	SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
    	SQLiteCommit($dbh);
	return 0;
}

sub updateTuple ($$$$) {
	my ($hashVarUpdBufRef, $hashRecordRef, $table, $dbh) = @_;
#    	print STDERR "BEGINUPDATE\n";
#    	my @Cols = keys %{$hashRecordRef};
    	my $update ;
    	while ( my ($key, $value) =  each %{$hashVarUpdBufRef} ) {
#        	print STDERR "\nEXAMINING KEY $key, VALUE IS $value \n \n";
                if ( exists $hashRecordRef->{$key} ) {
        		unless ( $value eq $hashRecordRef->{$key} ) {
#                              	print STDERR "PASSED COL $key = $hashRecordRef->{$key} \n";
#                              	print STDERR "PASSED COL $key = $hashVarUpdBufRef->{$key} \n";
    				$update .= "$key='".$value."',";
                        }
                }
    	}
#       print STDERR "UPDATE $update \n";
# Only update if the user modified any data
        if ( $update ) {
#        	print STDERR "In UPDATE \n";
#                unless (SQLiteGetGlobal($dbh,"UNDOONOFF") eq 'ON') {
#			SQLiteDo($dbh, "INSERT INTO undolog VALUES(NULL,'BEGINTRANS')");
#                        SQLiteSetUndoTrigger($dbh,$table);
#                }
                my $sqlstmt = "UPDATE $table SET ".$update;
    		$sqlstmt =~ s/,$/ WHERE pkey='$hashRecordRef->{pkey}'/;
#    		print STDERR "$table TABLE UPDATE => $sqlstmt \n ";
    		SQLiteDo($dbh, $sqlstmt);
                SQLiteDo($dbh, "UPDATE globals SET MYCOMMIT='YES' WHERE pkey='global'");
                SQLiteCommit($dbh);
	}
	return 0;
}


#
#  SQLite abstraction
#

sub SQLiteConnect() {
    # make connection to database
#    print STDERR "IN CONNECT\n\n";
    $dbh = DBI->connect( "dbi:SQLite:dbname=/opt/sark/db/sark.db","", "", { RaiseError => 1, AutoCommit => 0 });
    return $dbh;
}

sub SQLiteDisconnect($) {
    my ($dbh) = shift;
#    print STDERR "IN DISCONNECT\n\n";
    # disconnect from database
    $dbh->commit();
    $dbh->disconnect;
}

sub SQLiteGetKeys($$) {
#
#   Return all of the keys for a given table
#
    my ($dbh, $getcmd) = @_;
#    print STDERR "GET KEYS - $getcmd \n";
    my $out;
    my @keys;
    my $sth = $dbh->prepare($getcmd);
    $sth->execute();
    $sth->bind_columns(\$out);
    while ($sth->fetch()) {
	push (@keys, $out);
    }
    $sth->finish();
    return @keys;
}

sub SQLiteGet($$) {
#
#  return a column value for a given key
#
    my ($dbh, $getcmd) = @_;
#    print STDERR "GET DIRECT - $getcmd \n";
    my $out;
#    print STDERR "SQLiteGet is running $getcmd\n";
    my $sth = $dbh->prepare($getcmd);
    $sth->execute();
    $sth->bind_columns(\$out);
    $sth->fetch();
    $sth->finish();
    return $out;
}

sub SQLiteGetCols($$) {
#
#  return an array of all of the column names in a table
#
    my ($dbh, $table) = @_;
    my @cols;
    my $sth = $dbh->prepare("PRAGMA table_info($table)");
    $sth->execute();
    my $out =  $sth->fetch();
    while ($out) {
	push (@cols, @$out[1]);
        $out =  $sth->fetch();
    }
    $sth->finish();
    return @cols;
}

sub SQLiteGetHashCols($$) {
#
#  return a hash of all of the column names in a table
#
    my ($dbh, $table) = @_;
#    print STDERR "BUILDING COLUMN HASH FOR TABLE=>$table \n";
    my %cols;
    my $sth = $dbh->prepare("PRAGMA table_info($table)");
    $sth->execute();
    my $out =  $sth->fetch();
    while ($out) {
	$cols{@$out[1]} = undef;
        $out =  $sth->fetch();
    }
    $sth->finish();

    return %cols;
}

sub SQLiteGetHash($$) {
#
#  Return an entire row as hash/value
#
    my ($dbh, $getcmd) = @_;
#    print STDERR "GETHASH - $getcmd\n";
    my $sth = $dbh->prepare($getcmd);
    $sth->execute();
    my $ret = $sth->fetchrow_hashref;
    $sth->finish();
    return %$ret;
}

sub SQLiteGetHashKey($$$) {
#
#  Return an entire row as hash/value
#
    my ($dbh, $getcmd,$key) = @_;
#    print STDERR "GETHASH - $getcmd\n";
    my $sth = $dbh->prepare_cached($getcmd);
    $sth->execute($key);
    my $ret = $sth->fetchrow_hashref;
    $sth->finish();
    return %$ret;
}


sub SQLiteGetGlobal($$) {
#
#   Return a single global variable by name
#
    my ($dbh, $getcmd) = @_;
    return SQLiteGet($dbh, "SELECT $getcmd FROM globals where pkey = 'global'");
}


sub SQLiteUpdate($$) {
#
#  Update a single key/value - not used as far as I know
#
    my ($dbh, $sqlcmd) = @_;
    my $sth = $dbh->prepare($sqlcmd);
    $sth->execute();
    $sth->finish();
    undef $sth;
}

sub SQLiteDelete($$) {
#
#   Delete a row
#
    my ($dbh, $delcmd) = @_;
    my $sth = $dbh->prepare($delcmd);
    $sth->execute();
    $sth->finish();
    undef $sth;
#    print STDERR "SQL DELETE issued $delcmd\n";
}

sub SQLiteDo($$) {
#
#   do the SQL and return nothing
#
    my ($dbh, $sqlcmd) = @_;
#    print STDERR "SQLDO - $sqlcmd\n";
    $dbh->do($sqlcmd);
}

sub SQLiteCommit($) {
#
#   Transaction COMMIT - Deprecated
#
#    print STDERR "SQLiteCommit\n";

#    my ($dbh) = shift;
#    unless (SQLiteGetGlobal($dbh,"UNDOONOFF") eq 'ON') {
#     	return 0;
#    }
#    $dbh->commit();
     return 0;
}

#
#  BEGIN/END TRANSACTION (FOR ROLLBACK)
#

sub printpages ($$) {
#
#   Deprecated
#
    my $pages = shift;
    my $page = shift;
    print '<div class="lpages">';
    if ($pages == 1) {
	print "</div>";
    	return 0;
    }
    my $i;
    for ($i=$pages;$i>=1;$i-- ) {
        unless ($i == $page) {
                    	print image_button(-name=>"page$i",
				-src=>"/sark-common/pages/numero_$i.png",
                                -style=>'border-style: none; margin: 4px 2px 4px 2px; float: right;',
                                -alt=>'page',
                                -title=>'Go To page ',
				);
        }
        else {
    			print image_button(-name=>"page$i",
				-src=>"/sark-common/pages/nnumero_$i.png",
                                -style=>'border-style: none; margin: 4px 2px 4px 2px; float: right;',
                                -alt=>'page',
                                -title=>'Go To page ',
				);
        }
    }

    print "</div>";
    return (0);
}

