
  $(document).ready(function() {

	$.validator.addMethod("tenant",function(value,element) {
		return this.optional(element) || /^[A-Za-z0-9-_]{2,30}$/i.test(value); 
	},"tenant format is [A-Za-z0-9-_]{2,30} i.e no spaces or specal characters, max length 30 chars");
	
	$.validator.addMethod("include",function(value,element) {
		return this.optional(element) || /^[A-Za-z0-9-_ ]*$/i.test(value); 
	},"format is [A-Za-z0-9-_ ]* or the keyword ALL (no special characters)");	
			
	$("#sarkclusterForm").validate ( {
	   rules: {
		   pkey: "required tenant",
		   include : "include"
	   },
	   messages: {
	   }	
				
	});  


	$('#clustertable').dataTable ( {
		"bInfo": false,
		"bPaginate": true,
		"bLengthChange": false,
		"sDom": '<"top"i>pt<"bottom"f>',
		"aoColumnDefs": [ 
			{ "bSortable": false, "aTargets": [ 1,2,3,4,5,6 ] },
			{ "sClass": 'bluetags', "aTargets": [ 1,2,3,4 ] }
		],
		"aoColumns": [ 
			{ "sName": "pkey" },
			{ "sName": "operator" },
			{ "sName": "include" },
			{ "sName": "abstimeout" },
			{ "sName": "chanmax" },
			{ "sName": null },
			{ "sName": null }
		] 

	} ).makeEditable({
			sUpdateURL: "/php/sarkcluster/update.php",
			sReadOnlyCellClass: "read_only",
			"aoColumns": [
				null,  	// pkey
				{
					type: 'select',
					tooltip: 'Double Click to select Operator',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/operator/list.php',
                    loadtype: 'GET'		
				},		// operator
				{
					type: 'textarea',
					submit:'Save',
					tooltip: 'Double Click to set includes',
					onblur: 'cancel',	
					placeholder: 'Null',
				},		// include				
				{
					cssclass:"number",
					tooltip: 'Double Click to set Abstimeout',
                    onblur: 'cancel',
                    submit: 'Save',
				}, 		// ato
				
                {
					cssclass:"number",
					tooltip: 'Double Click to set Chanmax',
                    onblur: 'cancel',
                    submit: 'Save',
                },		// chanmax
                null, 	// oclo
				null	// delete col
            ]
        });  
        
      });
      
 
