<?php
//
// Developed by CoCo
// Copyright (C) 2012 CoCoSoft
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
require_once "../srkPageClass";
require_once "../srkDbClass";
require_once "../srkHelperClass";
require_once "../formvalidator.php";


Class edit {
	
	protected $message; 
	protected $myPanel;
	protected $dbh;
	protected $helper;
	protected $validator;
	protected $invalidForm;
	protected $error_hash = array();

public function showForm() {
	
	$this->myPanel = new page;
	$this->dbh = DB::getInstance();
	$this->helper = new helper;
		
	echo '<body>';
	echo '<form id="sarkeditForm" action="' . $_SERVER['PHP_SELF'] . '" method="post">' . PHP_EOL;
	
	$this->myPanel->pagename = 'Edit';
	
	if (isset($_GET['edit'])) { 
		$this->showEdit();	
		return;
	}	

	if (isset($_POST['update_x'])) { 
		$this->saveEdit();
		if ($this->invalidForm) {
			$this->showEdit();
			return;
		}					
	}
	
	$this->showMain();
	
	$this->dbh = NULL;
	return;
	
}
	
private function showMain() {
	
	if (isset($this->message)) {
		$this->myPanel->msg = $this->message;
	} 
	
	$astfiles = array();
	$tuple = array();	

/* 
 * start page output
 */
  
	echo '<div class="buttons">';	

	echo '</div>';	
	
	$this->myPanel->Heading();
/*
 * read the asterisk files and create an array of filename=>filetype
 */ 

	if ($handle = opendir('/etc/asterisk')) {
		while (false !== ($entry = readdir($handle))) {
			if ($entry != '.' && $entry != '..') {
				array_push($astfiles, $entry);
			}
		}	
		closedir($handle);
	}

	echo '<table cellpadding="0" cellspacing="0" border="0" class="display" width="40%" id="edittable"  >' ;	


	echo '<thead>' . PHP_EOL;	
	echo '<tr>' . PHP_EOL;
	

	$this->myPanel->aHeaderFor('astfilename');
	echo '<th class="srk-border" style="color:#ffffff">Edit</th>' . PHP_EOL;    // Del
	
	echo '</tr>' . PHP_EOL;
	echo '</thead>' . PHP_EOL;
	echo '<tbody>' . PHP_EOL;
	
/**** table rows ****/	
	foreach ($astfiles as $file ) {

		echo '<tr id="' . $file . '">'. PHP_EOL; 
		echo '<td class="read_only">/etc/asterisk/' . $file. '</td>' . PHP_EOL;
		$get = '?edit=yes&amp;pkey=';
		$get .= $file;	
		$this->myPanel->editClick($_SERVER['PHP_SELF'],$get);
			
		echo '</td>' . PHP_EOL;
		echo '</tr>'. PHP_EOL;
	}

	echo '</tbody>' . PHP_EOL;
	echo '</table>' . PHP_EOL;
		
}

private function showEdit() {
	$readOnlyFiles = array(
        "agents.conf"						=> null,
#        "chan_dahdi.conf"				=> null,
        "dahdi-channels.conf"				=> null,
		"extensions.conf"					=> null,
        "features.conf"					=> null,
        "iax.conf"						=> null,
        "queues.conf"						=> null,
        "sip.conf"						=> null,
        "voicemail.conf"					=> null,
        "sark_agents_main.conf"  			=> null,
        "sark_iax_localnet_header.conf"  	=> null,
        "sark_iax_main.conf"  			=> null,
        "sark_iax_registrations.conf"     => null,
        "sark_queues_main.conf"  			=> null,
        "sark_sip_localnet_header.conf"  	=> null,
        "sark_sip_main.conf"  			=> null,
        "sark_sip_registrations.conf"  	=> null,
        "cdr_mysql.conf"  				=> null,
	);
	
	if (isset ($_GET['pkey'])) {
		$pkey = $_GET['pkey']; 
	}
	$file = file("/etc/asterisk/$pkey") or die("Could not read file $pkey !");
	
	foreach ($file as $rec) {
		$astfile .= $rec;
	}
	
	$printline = "File " . $pkey;
	$this->myPanel->msg .= $printline; 
	
	if (isset($this->message)) {
		$this->myPanel->msg .= $this->message;
	} 
	
	echo '<div class="buttons">';
	$this->myPanel->Button("cancel");
	$this->myPanel->override = "update";
	$this->myPanel->Button("save");
	echo '</div>';	
		
	$this->myPanel->Heading();
	if (isset($this->message)) {	
		foreach($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}
	echo '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small;" >Asterisk File</span></span><br/>'. PHP_EOL;
   	if (array_key_exists($pkey,$readOnlyFiles)) {
		echo '<textarea rows="20" cols="100" readonly="readonly" style = "background-color: lightgrey" name="astfile" id="astfile">' . $astfile . '</textarea>' . PHP_EOL;
	}
	else { 	
		echo '<textarea rows="20" cols="100" name="astfile" id="astfile">' . $astfile . '</textarea>' . PHP_EOL;  
	}
	echo '<input type="hidden" name="pkey" id="pkey" value="' . $pkey . '"  />' . PHP_EOL; 
			
}


private function saveEdit() {
// save the data away
//print_r ($_POST) ;

	$tuple = array();
	if (isset ($_POST['pkey'])) {
		$pkey = $_POST['pkey']; 
	}
	if (isset ($_POST['astfile'])) {
		$astfile = strip_tags($_POST['astfile']); 
	}
	$astfile = preg_replace ( "/\\\/", '', $astfile);	
		
	$this->validator = new FormValidator();

    //Now, validate the form
    if ($this->validator->ValidateForm()) {
		$fh = fopen("/etc/asterisk/$pkey", 'w') or die("Could not open file $pkey!");
		fwrite($fh,$astfile) or die("Could not write to file $pkey");
		fclose($fh);
	}
	$this->message = " Updated $pkey";
}

}
