<?php
//
// Developed by CoCo
// Copyright (C) 2012 CoCoSoft
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
require_once "../srkPageClass";
require_once "../srkDbClass";
require_once "../srkHelperClass";
require_once "../formvalidator.php";
require_once "../AsteriskManager.php";


Class extension {
	
	protected $message; 
	protected $myPanel;
	protected $dbh;
	protected $helper;
	protected $validator;
	protected $invalidForm;
	protected $error_hash = array();
	protected $params = array('server' => '127.0.0.1', 'port' => '5038');

public function showForm() {
//	$params = array('server' => '127.0.0.1', 'port' => '5038');
	
	$this->myPanel = new page;
	$this->dbh = DB::getInstance();
	$this->helper = new helper;
	

	
	echo '<body>';
	echo '<form id="sarkextensionForm" action="' . $_SERVER['PHP_SELF'] . '" method="post">';
	
	$this->myPanel->pagename = 'Extensions';
	
	if (isset($_POST['new_x'])) { 
		$this->showNew();
		return;		
	}
	
	if (isset($_GET['edit'])) { 
		$this->showEdit();	
		return;
	}	

	if (isset($_POST['resetvmail_x'])) { 
		$rc = $this->helper->request_syscmd ("/bin/rm -rf /var/spool/asterisk/voicemail/default/" . $_POST['pkey']."/*");	
		$this->message = "Voicemail for Ext " . $_POST['pkey'] . " deleted";	
	}	
	
	if (isset($_POST['resetvmailpwd_x'])) { 
		$skey = $_POST['pkey'];
		$rc = $this->helper->request_syscmd ("/bin/sed -i 's/^$skey => [0-9]*\(.*\)/$skey => $skey\\1/' /etc/asterisk/voicemail.conf");	
		$this->message = "Voicemail password for Ext " . $_POST['pkey'] . " reset";	
	}	
	
	if (isset($_GET['notify'])) { 
		$this->sipNotify();
	}		

	if (isset($_POST['save_x'])) { 
		$this->saveNew();
		if ($this->invalidForm) {
			$this->showNew();
			return;
		}					
	}
	
	if (isset($_POST['update_x'])) { 
		$this->saveEdit();
		if ($this->invalidForm) {
			$this->showEdit($_POST['pkey']);
			return;
		}					
	}

	if (isset($_POST['commit_x']) || isset($_POST['commitClick_x'])) { 
		$this->helper->sysCommit();
		$this->message = "Updates have been Committed";	
	}
		
	$this->showMain();
	
	$this->dbh = NULL;
	return;
	
}
	

private function showMain() {
	
	if (isset($this->message)) {
		$this->myPanel->msg = $this->message;
	} 
/*
 * sign on to the AMI and build a peer array
 */
	$astrunning = false;
	if ( $this->helper->check_pid() ) {	
		$astrunning = true;
	}
		
	$sip_peers = array(); 	
	if ( $astrunning ) {			
		$ami = new ami($this->params);
		$ami->connect();
		$ami->login('sark','mysark');
		$amisiprets = $ami->getSipPeers();
		$sip_peers = $this->build_peer_array($amisiprets);
		$ami->logout();
	}
	else {
		$this->myPanel->msg .= "  (No Asterisk running)";
	}

/* 
 * start page output
 */
  
	$res = $this->dbh->query("SELECT PROXY FROM globals where pkey = 'global'")->fetch(PDO::FETCH_ASSOC);
	$proxy = $res['PROXY'];
	echo '<div class="buttons">';	
	$this->myPanel->Button("new");
	$this->myPanel->commitButton();
	echo '</div>';	
	
	$this->myPanel->Heading();

	echo '<table cellpadding="0" cellspacing="0" border="0" class="display" id="extensiontable" width="20%"  >' ;
	echo '<thead>' . PHP_EOL;	
	echo '<tr>' . PHP_EOL;
	

	$this->myPanel->aHeaderFor('ext'); 	
	$this->myPanel->aHeaderFor('cluster');
	$this->myPanel->aHeaderFor('uname');
	$this->myPanel->aHeaderFor('device');
	$this->myPanel->aHeaderFor('macaddr');
	$this->myPanel->aHeaderFor('ipaddr');
	$this->myPanel->aHeaderFor('headlocation');	
	$this->myPanel->aHeaderFor('latency');
	$this->myPanel->aHeaderFor('ct');
	$this->myPanel->aHeaderFor('bt');
//	$this->myPanel->aHeaderFor('vr');
	echo '<th class="srk-border" style="color:#ffffff">Edit</th>' . PHP_EOL;   // edit 	
	echo '<th class="srk-border" style="color:#ffffff">Del</th>' . PHP_EOL;  // Del
	
	echo '</tr>' . PHP_EOL;
	echo '</thead>' . PHP_EOL;
	echo '<tbody>' . PHP_EOL;
		
/*** table rows ****/

	$rows = $this->helper->getTable("ipphone","select ip.*, de.noproxy from ipphone ip inner join device de on ip.device=de.pkey");
	foreach ($rows as $row ) {
		echo '<tr id="' . $row['pkey'] . '">'. PHP_EOL; 
		echo '<td class="read_only">' . $row['pkey'] . '</td>' . PHP_EOL;		
		echo '<td >' . $row['cluster'] . '</td>' . PHP_EOL;
		
		$display = $row['desc'];
		if ( strlen($row['desc']) > 7 ) {
			$display = substr($row['desc'] , 0, 5);
			$display .= '.';
		}			 
		echo '<td  title = "' . $row['desc'] . '" >' . $display  . '</td>' . PHP_EOL;
		
		$display = $row['device'];
		if ( strlen($row['device']) > 8 ) {
			$display = substr($row['device'] , 0, 7);
			$display .= '.';
		}			 
		echo '<td  title = "' . $row['device'] . '" >' . $display  . '</td>' . PHP_EOL;	
		
		$display_macaddr = 'N/A';
		if (!empty ($row['macaddr'])) {
			$display_macaddr = $row['macaddr'];
		}		
		echo '<td >' . $display_macaddr . '</td>' . PHP_EOL;
		
		$display_ipaddr = 'N/A';		
		if ($row['technology'] != 'SIP') {
			$display_ipaddr = $row['technology'];
		}		
		else if (isset ($sip_peers [$row['pkey']]['IPaddress']) && $sip_peers [$row['pkey']]['IPaddress'] == '-none-') {		
			if (preg_match(' /(..)(..)(..)(..)(..)(..)/ ',$row['macaddr'],$matches)) {
				$formalmac = strtoupper($matches[1] . ':' . $matches[2] . ':' . $matches[3] . ':' . $matches[4] . ':' . $matches[5] . ':' . $matches[6]);		
				$mac = `/bin/grep $formalmac /proc/net/arp`;			
				if (!empty ($mac)) {
					preg_match(' /^(\d+\.\d+\.\d+\.\d+)/ ',$mac,$match);
					$display_ipaddr = $match[1];
				}
			}
		}
		else if (isset ($sip_peers [$row['pkey']]['IPaddress'])) {
			$display_ipaddr = $sip_peers [$row['pkey']]['IPaddress'];
		}		
		
		echo '<td >' . $display_ipaddr . '</td>' . PHP_EOL;
		echo '<td >' . $row['location'] . '</td>' . PHP_EOL;
		
		$latency = 'N/A';
		if (isset($sip_peers [$row['pkey']]['Status'])) {
			if (preg_match(' /\((\d+)\sms/ ',$sip_peers [$row['pkey']]['Status'],$matches)) {
				$latency = 	$matches[1] . 'ms';
			}
		}	
		echo '<td >' . $latency . '</td>' . PHP_EOL;
		
		if (isset($matches[1]) && is_numeric($matches[1])) {
			if ($row['location'] == "remote" || $proxy == "NO" || $row['noproxy']  ) {
                echo '<td><img src="/sark-common/actions/apply.png" border=0 title = "Device is on-line" ></td>' . PHP_EOL;		
			}
			else {
				echo '<td><a href="/DPRX' . $display_ipaddr . '/"><img src="/sark-common/connected.png" border=0 title = "Device is online and registered"></a></td>' . PHP_EOL;	
			} 
		}
		else {
			if ($row['technology'] != 'SIP') {
				echo '<td><img src="/sark-common/actions/apply.png" border=0 title = "Device is on-line" ></td>' . PHP_EOL;
			}
			else {
				if ($display_ipaddr != 'N/A') {
					echo '<td><a href="/DPRX' . $display_ipaddr . '/"><img src="/sark-common/warning.png" border=0 title = "Device is online but not registered (this may be OK)"></a></td>' . PHP_EOL;
				}
				else { 
					echo '<td><img src="/sark-common/actions/no.png" border=0 title = "Device is Offline" ></td>' . PHP_EOL;
				}
			}
		}


		
		if ($row['technology'] == 'SIP') {		
			$get = '?notify=yes&amp;pkey=';
			$get .= $row['pkey'];	
			$this->myPanel->notifyClick($_SERVER['PHP_SELF'],$get);	
		}
		else {
			echo '<td>N/A</td>' . PHP_EOL;
		}
/*		
		$get = '?reset=yes&amp;pkey=';
		$get .= $row['pkey'];	
		echo '<td><a href="';
		echo $_SERVER['PHP_SELF'];
		echo "?reset=yes&amp;pkey=";
		echo $row['pkey'];
		echo '"><img src="/sark-common/editshred.png" border=0 title = "reset (delete all) Voicemail" onclick = "return confirmOK(\'All voicemail will be deleted for this extension - Confirm?\')"></a></td>';
		echo "\n";
*/
		$get = '?edit=yes&amp;pkey=';
		$get .= $row['pkey'];	
		$this->myPanel->editClick($_SERVER['PHP_SELF'],$get);
		echo '<td ><a class="table-action-deletelink" href="/php/sarkextension/delete.php?id=' . $row['pkey'] . '"><img src="/sark-common/edittrash.png" border=0 title = "Click to Delete" ></a></td>' . PHP_EOL;				
		echo '</td>' . PHP_EOL;
		echo '</tr>'. PHP_EOL;

	}

	echo '</tbody>' . PHP_EOL;
	echo '</table>' . PHP_EOL;
	
}

private function showNew() {
	$this->myPanel->msg .= "Add an Extension "; 
	
	if (isset($this->message)) {
		$this->myPanel->msg .= $this->message;
	}  
	
	echo '<div class="buttons">';
	$this->myPanel->Button("cancel");
	$this->myPanel->Button("save");
	echo '</div>';			
	
	$this->myPanel->Heading();
	if (isset($this->message)) {	
		foreach($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}
// find the next available ext#	
	$res = $this->dbh->query("SELECT SIPIAXSTART FROM globals where pkey = 'global'")->fetch(PDO::FETCH_ASSOC);
	$pkey = $res['SIPIAXSTART'];
	$res = $this->dbh->query("SELECT pkey FROM ipphone where pkey = '" . $pkey . "'")->fetch(PDO::FETCH_ASSOC);
	while ( isset($res['pkey']) ) {
		$pkey++;
		$res = $this->dbh->query("SELECT pkey FROM ipphone where pkey = '" . $pkey . "'")->fetch(PDO::FETCH_ASSOC);
	}

	$res = $this->dbh->query("SELECT pkey from device WHERE (technology='SIP' OR technology='IAX2' OR technology='Custom') AND legacy IS NULL ORDER BY pkey");  
	$res->setFetchMode(PDO::FETCH_COLUMN, 0);   
	$devices = $res->fetchAll(); 
	
	echo '<br /><br />'. PHP_EOL;
	$this->myPanel->aLabelFor('rule');
	echo '<input type="text" name="pkey" size="3" id="pkey" value="' . $pkey . '"  />' . PHP_EOL;
	$this->myPanel->aLabelFor('device');
	$this->myPanel->popUp('device', $devices);
	$this->myPanel->aLabelFor('devicerec');
	$this->myPanel->popUp('devicerec', array('default','None','OTR','OTRR','Inbound','Outbound'));
	$this->myPanel->aLabelFor('vmailfwd');
	echo '<input type="text" name="vmailfwd" id="vmailfwd" size="20"  />' . PHP_EOL;
	$this->myPanel->aLabelFor('macaddr');
	echo '<input type="text" name="macaddr" id="macaddr" size="10"  />' . PHP_EOL;
	$this->myPanel->aLabelFor('calleridname');
	echo '<input type="text" name="desc" id="desc"  value="Ext' . $pkey . '"  />' . PHP_EOL;
	$this->myPanel->aLabelFor('location');
	$this->myPanel->popUp('location', array('local','remote'));
	$this->myPanel->aLabelFor('cluster');
	$this->myPanel->displayCluster();
	$this->myPanel->aLabelFor('extalert');
	echo '<input type="text" name="extalert" id="extalert" size="20"   />' . PHP_EOL;
	$this->myPanel->aLabelFor('callerid');
	echo '<input type="text" name="callerid" id="callerid" size="10"  />' . PHP_EOL;
	$this->myPanel->aLabelFor('cdialstring');
	echo '<input type="text" name="dialstring" id="dialstring" size="20"  />' . PHP_EOL;
		
}

private function saveNew() {
// save the data away
	
	$tuple = array();
	
	$res = $this->dbh->query("SELECT EXTLEN,ACL FROM globals WHERE pkey = 'global'")->fetch(PDO::FETCH_ASSOC);
	$acl = $resglobal['ACL'];
	$extlen = $resglobal['EXTLEN'];
	
	$this->validator = new FormValidator();
	$this->validator->addValidation("pkey","req","Please fill in extension number");
	$this->validator->addValidation("pkey","num","extension number must be numeric");
/*	
	$this->validator->addValidation("pkey","minlen=" . $extlen,"ext length incorrect");
	$this->validator->addValidation("pkey","maxlen=" . $extlen,"ext length incorrect");
	*/
	
    $this->validator->addValidation("vmailfwd","email","Invalid email address format");
    $this->validator->addValidation("callgroup","alnum","Call Group name must be alphanumeric(no spaces)");  
    $this->validator->addValidation("macaddr","regexp=/^[0-9a-fA-F]{12}|\s*$/","Mac address is invalid");  

    //Now, validate the form
    if ($this->validator->ValidateForm()) {
		
		$tuple['pkey'] 			= strip_tags($_POST['pkey']);
		$tuple['device'] 		= $_POST['device'];
		$tuple['devicerec'] 		= $_POST['devicerec'];
		$tuple['vmailfwd'] 		= strip_tags($_POST['vmailfwd']);		
		$tuple['macaddr']		= strip_tags($_POST['macaddr']);

		if (isset ($_POST['desc'])) {
			if ($_POST['desc']) {
				$tuple['desc']	= strip_tags($_POST['desc']);			
			}
			else {
				$tuple['desc']	= "Ext".$tuple['pkey'];
			}
		}	
				
		$tuple['location'] 		= $_POST['location'];		

		if (isset ($_POST['cluster'])) {
			$tuple['cluster']	= strip_tags($_POST['cluster']);
		}
		else {
			$tuple['cluster']	='Default';
		}		
		$tuple['extalert']		= strip_tags($_POST['extalert']);
		
		if (isset ($_POST['callerid'])) {
			$tuple['callerid']	= strip_tags($_POST['callerid']);
		}
		else {
			$tuple['callerid']	= $tuple['pkey'];
		}
				
		$tuple['dialstring']	= strip_tags($_POST['dialstring']);
		
		$resdevice 		= $this->dbh->query("SELECT sipiaxfriend,provision,technology FROM device WHERE pkey = '" . $tuple['device'] . "'")->fetch(PDO::FETCH_ASSOC);
		$tuple['sipiaxfriend'] 	= $resdevice['sipiaxfriend'];
		$tuple['provision']		= $resdevice['provision'];
		$tuple['technology']	= $resdevice['technology'];	
		
		
		
		
		$password 		= $this->helper->ret_password ();
		$tuple['passwd']	=  $password;
			
		$localip = $this->helper->ret_localip ();
			
		$astclistr = 'callerid="$desc" <$ext>';
		if ( preg_match(' /callerid=/ ',$tuple['sipiaxfriend']))	{			
			$tuple['sipiaxfriend'] = preg_replace ( '/callerid=/', $astclistr, $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\n";
			$tuple['sipiaxfriend'] .= $astclistr;
		}
			
		$astuser = 'username=$desc';	
		if ( preg_match(' /username=/ ',$tuple['sipiaxfriend']))	{			
			$tuple['sipiaxfriend'] = preg_replace ( '/username=/', $astuser, $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\n";
			$tuple['sipiaxfriend'] .= $astuser;
		}	
			
		$astpassword = 'secret=$password';	
		if ( preg_match(' /secret=/ ',$tuple['sipiaxfriend'])) {				
			$tuple['sipiaxfriend'] = preg_replace ( '/secret=/', $astpassword, $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\n";
			$tuple['sipiaxfriend'] .= $astpassword;
		}	
			
		$astmailbox = 'mailbox=$ext';				
		if ( preg_match(' /mailbox=/ ',$tuple['sipiaxfriend']))	{			
			$tuple['sipiaxfriend'] = preg_replace ( '/mailbox=/', $astmailbox, $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\n";
			$tuple['sipiaxfriend'] .= $astmailbox;
		}
			
		if ( preg_match(' /pickupgroup=/ ',$tuple['sipiaxfriend']))	{			
			$tuple['sipiaxfriend'] = preg_replace ( '/pickupgroup=/', 'pickupgroup=1', $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\npickupgroup=1";
		}
		if ( preg_match(' /callgroup=/ ',$tuple['sipiaxfriend']))	{			
			$tuple['sipiaxfriend'] = preg_replace ( '/callgroup=/', 'callgroup=1', $tuple['sipiaxfriend']);
		}
		else {
			$tuple['sipiaxfriend'] .= "\ncallgroup=1";
		}
		if ($acl == 'YES' && $tuple['location'] == 'local') {
			if ( !preg_match(' /deny=/ ',$tuple['sipiaxfriend'])) {
				$tuple['sipiaxfriend'] .= "\ndeny=0.0.0.0/0.0.0.0";
			}
			if ( !preg_match(' /permit=/ ',$tuple['sipiaxfriend'])) {
				$tuple['sipiaxfriend'] .= "\npermit=$localip/255.255.255.0";
			}				
		}
		if ( !preg_match(' /call-limit/ ',$tuple['sipiaxfriend'])) {
			$tuple['sipiaxfriend'] .= "\ncall-limit=3";
		}
		if ( !preg_match(' /subscribecontext/ ',$tuple['sipiaxfriend'])) {
			$tuple['sipiaxfriend'] .= "\nsubscribecontext=extensions";
		}
		$tuple['sipiaxfriend'] .= "\ndisallow=all ";
		$tuple['sipiaxfriend'] .= "\nallow=alaw\nallow=ulaw ";
		if ($tuple['location'] == 'remote') {
			$tuple['sipiaxfriend'] .= "\nnat=yes";	
		}
		$tuple['sipiaxfriend'] = trim($tuple['sipiaxfriend']);
		$tuple['provision'] = trim($tuple['provision']);
		$tuple['provision'] = preg_replace ( '/¬/', '|', $tuple['provision']);
//		$tuple['provision'] = preg_replace ( '/\$desc/', $tuple['desc'], $tuple['provision']);
//		$tuple['provision'] = preg_replace ( '/\$ext/', $tuple['pkey'], $tuple['provision']);
//		$tuple['provision'] = preg_replace ( '/\$password/', $password, $tuple['provision']);
		
		$sql = "SELECT * FROM COS ORDER BY pkey";
		foreach ($this->dbh->query($sql) as $cos) {
			if ($cos['defaultopen'] == 'YES') {
				$res=$this->dbh->prepare('INSERT INTO IPphoneCOSopen(IPphone_pkey,COS_pkey) VALUES(?,?)');
				$res->execute(array( $pkey,$cos['pkey'] ));
			}
			if ($cos['defaultclosed'] == 'YES') {
				$res=$this->dbh->prepare('INSERT INTO IPphoneCOSclosed(IPphone_pkey,COS_pkey) VALUES(?,?)');
				$res->execute(array( $pkey,$cos['pkey'] ));
			}			
		}		 		   
		$ret = $this->helper->createTuple("ipphone",$tuple);
		if ($ret == 'OK') {
			$this->message = "Saved new extension " . $tuple['pkey'] . "!";
		}
		else {
			$this->invalidForm = True;
			$this->message = "<B>  --  Validation Errors!</B>";	
			$this->error_hash['exteninsert'] = $ret;	
		}	
	}
    else {
		$this->invalidForm = True;
		$this->error_hash = $this->validator->GetErrors();
		$this->message = "<B>  --  Validation Errors!</B>";		
    }
    unset ($this->validator);
}

private function showEdit($key=False) {
	
	if ($key != False) {
		$pkey=$key;
	}
	else {
		$pkey = $_GET['pkey']; 
	}
	$extension = $this->dbh->query("SELECT * FROM IPphone WHERE pkey = '" . $pkey . "'")->fetch(PDO::FETCH_ASSOC);
	$extlist=array();
	array_push($extlist,"None");
	
	$res = $this->helper->getTable("ipphone","select pkey from ipphone");
	foreach ($res as $row) {
		array_push($extlist,$row['pkey']);
	}
	
	$printline = "Ext " . $extension['technology'] . "/" . $extension['pkey'] . ', "' . $extension['desc'] . '"(' . $extension['device'] . ')';
	$this->myPanel->msg .= $printline; 
	
	if (isset($this->message)) {
		$this->myPanel->msg .= $this->message;
	} 
	
	$ami = new ami($this->params);
	$ami->connect();
	$ami->login('sark','mysark');
	$cfim = $ami->GetDB('cfim', $pkey);
	$cfbs = $ami->GetDB('cfbs', $pkey);
	$ringdelay = $ami->GetDB('ringdelay', $pkey);
	$ami->logout();
	
	$xref = $this->xRef($pkey);
	
	echo '<div class="buttons">';
	$this->myPanel->Button("cancel");
	$this->myPanel->override="update";
	$this->myPanel->Button("save");
	$this->myPanel->Button("resetvmail");
	$this->myPanel->Button("resetvmailpwd");
	echo '</div>';	
		
	$this->myPanel->Heading();
	if (isset($this->message)) {	
		foreach($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}	
	echo '<br/>'. PHP_EOL;		

	echo '<div id="pagetabs"  class="ui-tabs">' . PHP_EOL;
	echo '<ul>' . PHP_EOL;
	echo '<li><a href="#general">General</a></li>'. PHP_EOL;
	if ($extension['technology'] == 'SIP' ||  $extension['technology'] == 'IAX') {
		echo  '<li><a href="#asterisk">Asterisk</a></li>' . PHP_EOL;
		echo  '<li><a href="#provisioning">Provisioning</a></li>' . PHP_EOL;
	}
	echo '<li><a href="#cos" >CoS</a></li>' . PHP_EOL;
	echo '<li><a href="#cfwd" >CFWD</a></li>' . PHP_EOL;
    echo '<li><a href="#xref" >XREF</a></li>' . PHP_EOL;
    echo '</ul>' . PHP_EOL;
    
/*
 *   TAB Provisioning
 */
    if ($extension['technology'] == 'SIP' ||  $extension['technology'] == 'IAX') {
    	echo '<div id="provisioning" class="ui-tabs-hide">';
		echo '<textarea rows="15" cols="100" name="provision" id="provision">' . htmlspecialchars($extension['provision']) . '</textarea>' . PHP_EOL;
		echo '</div>' . PHP_EOL;
	}
	
/*
 *   TAB Asterisk
 */
	if ($extension['technology'] == 'SIP' ||  $extension['technology'] == 'IAX') {
    	echo '<div id="asterisk" class="ui-tabs-hide">';
		echo '<textarea rows="15" cols="100" name="sipiaxfriend" id="sipiaxfriend">' . htmlspecialchars($extension['sipiaxfriend']) . '</textarea>' . PHP_EOL;
		echo '</div>' . PHP_EOL;
	}
	
/*
 * 	TAB General
 */  
    echo '<div id="general" class="ui-tabs-hide">';
    
    $this->myPanel->aLabelFor('rule');
	echo '<input type="text" name="newkey" size="3" id="newkey" value="' . $extension['pkey'] . '"  />' . PHP_EOL;
	
	$this->myPanel->aLabelFor('calleridname');
	echo '<input type="text" name="desc" id="desc" value="' . $extension['desc'] . '" />' . PHP_EOL;

	$this->myPanel->aLabelFor('password');
	echo '<input type="text" name="passwd" id="passwd" value="' . $extension['passwd'] . '" />' . PHP_EOL;	

	if ($extension['technology'] == 'SIP' ||  $extension['technology'] == 'IAX') {
		$this->myPanel->aLabelFor('macaddr');
		echo '<input type="text" name="macaddr" id="macaddr" size="14" ';
		
			if ( preg_match(' /VXT/ ',$extension['device']))	{
			echo 'style = "background-color: lightgrey" readonly="readonly" '; 
			 
		}
		echo 'value="' . $extension['macaddr'] . '"  />' . PHP_EOL;
	}
    
    $this->myPanel->aLabelFor('vmailfwd');
	echo '<input type="text" name="vmailfwd" id="vmailfwd" size="30"  value="' . $extension['vmailfwd'] . '"  />' . PHP_EOL;	
	$this->myPanel->aLabelFor('cluster');
	$this->myPanel->selected = $extension['cluster'];
	$this->myPanel->displayCluster();
 	$this->myPanel->aLabelFor('devicerec');
 	$this->myPanel->selected = $extension['devicerec'];
 	$this->myPanel->popUp('devicerec', array('default','None','OTR','OTRR','Inbound','Outbound'));	
	if ($extension['technology'] == 'SIP' ) {
		$this->myPanel->aLabelFor('location');
		$this->myPanel->selected = $extension['location'];
		$this->myPanel->popUp('location', array('local','remote'));
	}
	
	$this->myPanel->aLabelFor('dvrvmail');	
	$this->myPanel->selected = $extension['dvrvmail'];
	$this->myPanel->popUp('dvrvmail', $extlist);		

//	echo '<input type="text" name="dvrvmail" id="dvrvmail" size="3"  value="' . $extension['dvrvmail'] . '"  />' . PHP_EOL;		

	$this->myPanel->aLabelFor('callerid');
	echo '<input type="text" name="callerid" id="callerid" size="10"  value="' . $extension['callerid'] . '"  />' . PHP_EOL;				
	if ($extension['technology'] == 'SIP' ) {
		$this->myPanel->aLabelFor('extalert');
		echo '<input type="text" name="extalert" id="extalert" size="40"  value="' . $extension['extalert'] . '"  />' . PHP_EOL;
	}	
	if ($extension['technology'] == 'Custom' ) {
		$this->myPanel->aLabelFor('cdialstring');
		echo '<input type="text" name="cdialstring" id="cdialstring" size="10"  value="' . $extension['cdialstring'] . '"  />' . PHP_EOL;
	}			
	echo '</div>' . PHP_EOL;
	
/*
 * 	TAB COS
 */ 	 
	echo '<div id="cos" class="ui-tabs-hide" >' . PHP_EOL;	
	echo '<br/>'. PHP_EOL;	
    echo '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Day-time Class of Service</span><br />'. PHP_EOL;	
    
    $classOfService = $this->helper->getTable("cos",$sql='',$filter=false);
    foreach ($classOfService as $cos) {
		$sql = "SELECT IPphone_pkey FROM IPphoneCOSopen where IPphone_pkey = '" . $extension['pkey'] . "' and COS_pkey = '" . $cos['pkey'] . "'";
		$cosrec = $this->dbh->query($sql)->fetch(PDO::FETCH_ASSOC);
       	if (is_array($cosrec) && array_key_exists('IPphone_pkey',$cosrec)) {
    		echo '<input type="checkbox" checked="yes" name="opencos[]" value="' . $cos['pkey'] . '" />' . $cos['pkey'] . '<br/>' . PHP_EOL;	 
        }
        else {
				echo '<input type="checkbox" name="opencos[]" value="' . $cos['pkey'] . '" />' . $cos['pkey'] . '<br/>' . PHP_EOL;			
        }
    }
    echo '<br/><br/><span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Night-time Class of Service</span><br />'. PHP_EOL;	
    foreach ($classOfService as $cos) {
		$sql = "SELECT IPphone_pkey FROM IPphoneCOSclosed where IPphone_pkey = '" . $extension['pkey'] . "' and COS_pkey = '" . $cos['pkey'] . "'";
		$cosrec = $this->dbh->query($sql)->fetch(PDO::FETCH_ASSOC);
       	if (is_array($cosrec) && array_key_exists('IPphone_pkey',$cosrec)) {
    		echo '<input type="checkbox" checked="yes" name="closedcos[]" value="' . $cos['pkey'] . '" />' . $cos['pkey'] . '<br/>' . PHP_EOL;	 
        }
        else {
				echo '<input type="checkbox" name="closedcos[]" value="' . $cos['pkey'] . '" />' . $cos['pkey'] . '<br/>' . PHP_EOL;			
        }
    }
	echo '</div>' . PHP_EOL;
	echo '<input type="hidden" name="pkey" id="pkey" size="20"  value="' . $pkey . '"  />' . PHP_EOL; 
	
/*
 * 	TAB Call Forwards
 */ 
	echo '<div id="cfwd" class="ui-tabs-hide" >' . PHP_EOL;
	echo '<br/>' . PHP_EOL;
    echo '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Call Forwards</span><br />' . PHP_EOL;
    echo '<br/>' . PHP_EOL;
    $this->myPanel->aLabelFor('cfim');
    echo '<input type="text" name="cfim" id="cfim" size="14"  value="' . $cfim . '"  />' . PHP_EOL;
    $this->myPanel->aLabelFor('cfbs');
    echo '<input type="text" name="cfbs" id="cfbs" size="14"  value="' . $cfbs . '"  />' . PHP_EOL;
    echo '<br/>' . PHP_EOL;
    echo '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Ring Time</span><br />' . PHP_EOL;
    echo '<br/>' . PHP_EOL;
    $this->myPanel->aLabelFor('ringdelay');
    echo '<input type="text" name="ringdelay" id="ringdelay" size="2"  value="' . $ringdelay . '"  />' . PHP_EOL;
	echo '</div>' . PHP_EOL;

/*
 * 	TAB XREF 
 */ 
	echo '<div id="xref" class="ui-tabs-hide" >' . PHP_EOL;
	echo '<span style="color: rgb(0, 0, 0); font-weight:bold; font-size:small; ">Cross References to this extension</span><br />' . PHP_EOL;
    echo '<br/>' . PHP_EOL;
    echo "$xref" . PHP_EOL;
    echo '<br/>' . PHP_EOL;
	echo '</div>' . PHP_EOL;			
}

private function saveEdit() {
// save the data away

	$tuple = array();
		
	$this->validator = new FormValidator();
	
	$this->validator->addValidation("newkey","num","Invalid extension number");
	$this->validator->addValidation("newkey","req","You must specify an extension number");
	$this->validator->addValidation("newkey","minlen=3","Invalid minimum extension number");
	$this->validator->addValidation("newkey","maxlen=4","Invalid maximum extension number");
    $this->validator->addValidation("vmailfwd","email","Invalid email address format");
    $this->validator->addValidation("callgroup","alnum","Call Group name must be alphanumeric(no spaces)");  
    $this->validator->addValidation("macaddr","regexp=/^[0-9a-fA-F]{12}|\s*$/","Mac address is invalid"); 
    $this->validator->addValidation("desc","regexp=/^[0-9a-zA-Z_-]+$/","Caller name is invalid - must be [0-9a-zA-Z_-]"); 
    $this->validator->addValidation("passwd","regexp=/^[0-9a-zA-Z]+$/","Password is invalid - must be [0-9a-zA-Z]"); 
    $this->validator->addValidation("cfim","num","Call forward must be numeric"); 
    $this->validator->addValidation("cfbs","num","Call forward must be numeric"); 
    $this->validator->addValidation("ringdelay","num","Ring Time must be numeric"); 
		
    //Now, validate the form
    if ($this->validator->ValidateForm()) {
/*
 * 	call the tuple builder to create a table row array 
 */ 
		$custom = array (
						'cfim' => True,
						'cfbs' => True,
						'ringdelay' => True,
						'opencos' => True,
						'closedcos' => True,
						'newkey' => True
//						'sipiaxfriend' => True
		);
		
		$this->helper->buildTupleArray($_POST,$tuple,$custom);
		$newkey =  trim(strip_tags($_POST['newkey']));

/*
 * local/remote processing
 */ 
		if (preg_match( " /nat=yes/ ", $tuple['sipiaxfriend']) ) {
			if ($tuple['location'] == 'local') {
				$tuple['sipiaxfriend'] = trim(str_replace("nat=yes", "", $tuple['sipiaxfriend']));
			}
		}
		else {
			if ($tuple['location'] == 'remote') {
				$tuple['sipiaxfriend'] .= "\nnat=yes";
			}
		}

		$cfim			= strip_tags($_POST['cfim']);
		$cfbs			= strip_tags($_POST['cfbs']);
		$ringdelay		= strip_tags($_POST['ringdelay']);	
/*	
 * update the asterisk internal database (callforwards and ringdelay)
 */ 		
		$ami = new ami($this->params);
		$ami->connect();
		$ami->login('sark','mysark');
		if (isset($_POST['cfim'])) {
			$ami->PutDB('cfim', $newkey, $cfim);
		}
		if (isset($_POST['cfbs'])) {
			$ami->PutDB('cfbs', $newkey, $cfbs);
		}
		if (isset($_POST['ringdelay'])) {
			$ami->PutDB('ringdelay', $newkey, $ringdelay);
		}					
		$ami->logout();		
/*
 * update the SQL database
 */
 
// remove any escaped quotes 			
		$tuple['provision'] = preg_replace ( "/\\\/", '', $tuple['provision']);
		$tuple['sipiaxfriend'] = preg_replace ( "/\\\/", '', $tuple['sipiaxfriend']);
		$this->doCos();
/*
 * check for keychange
 */
		if ($newkey != $tuple['pkey']) {
			$res = $this->dbh->query("SELECT pkey FROM ipphone WHERE pkey = '" . $newkey . "'")->fetch(PDO::FETCH_ASSOC);
			if ( isset($res['pkey']) ) { 
				$this->invalidForm = True;
				$this->message = "<B>  --  Validation Errors!</B>";	
				$this->error_hash['extensave'] = " Attempt to change extension key but " . $newkey . " already exists!";	
			}
			else {
				// set the mailbox to the new extension
				$tuple['dvrvmail'] = $newkey;
				$ret = $this->helper->setTuple("ipphone",$tuple,$newkey);
				if ($ret == 'OK') {
					$this->message = "Updated extension ";
					// move any mail
					$maildir = '/var/spool/asterisk/voicemail/default/'.$tuple['pkey'];
					if (is_dir($maildir)) {
						$oldmail = '/var/spool/asterisk/voicemail/default/'.$tuple['pkey'];
						$newmail = '/var/spool/asterisk/voicemail/default/'.$newkey;
						$this->helper->request_syscmd ("/bin/mv $oldmail $newmail");
					}
				}
				else {
					$this->invalidForm = True;
					$this->message = "<B>  --  Validation Errors!</B>";	
					$this->error_hash['extensave'] = $ret;	
				}
			}
		}
		else {		
			$ret = $this->helper->setTuple("ipphone",$tuple,$newkey);
			if ($ret == 'OK') {
				$this->message = "Updated extension ";
			}
			else {
				$this->invalidForm = True;
				$this->message = "<B>  --  Validation Errors!</B>";	
				$this->error_hash['extensave'] = $ret;	
			}
		}			
	}
    else {
		$this->invalidForm = True;
		$this->error_hash = $this->validator->GetErrors();
		$this->message = "<B>  --  Validation Errors!</B>";		
    }
    unset ($this->validator);
}

private function doCOS() {
# Do the Booleans
	$tuple = array();

/*
 * delete the existing rows (if any)
 */ 
	 $this->helper->predDelTuple("IPphoneCOSopen","IPphone_pkey",$_POST['pkey']);
	 $this->helper->predDelTuple("IPphoneCOSclosed","IPphone_pkey",$_POST['pkey']);
/*
 * add these rows
 */ 	
	if ( isset ($_POST['opencos']) && is_array($_POST['opencos'])) {
		foreach ( $_POST['opencos'] as $ocos ) {
			$tuple['IPphone_pkey'] = $_POST['pkey'];
			$tuple['COS_pkey'] = $ocos;
			$ret = $this->helper->createTuple("IPphoneCOSopen",$tuple,false);
			if ($ret != 'OK') {
				$this->invalidForm = True;
				$this->message = "<B>  --  Validation Errors!</B>";	
				$this->error_hash['opencos'] = $ret;	
			}
		}
	}
	if ( isset($_POST['closedcos']) && is_array($_POST['closedcos'])) {
		foreach ( $_POST['closedcos'] as $ccos ) {
			$tuple['IPphone_pkey'] = $_POST['pkey'];
			$tuple['COS_pkey'] = $ccos;
			$ret = $this->helper->createTuple("IPphoneCOSclosed",$tuple,false);
			if ($ret != 'OK') {
				$this->invalidForm = True;
				$this->message = "<B>  --  Validation Errors!</B>";	
				$this->error_hash['opencos'] = $ret;	
			}
		}
	}		
/*
#    	print STDERR "@opencos element is $_ \n";
    	unless (SarkSubs::SQLiteGet($dbh, "SELECT IPphone_pkey FROM IPphoneCOSopen where IPphone_pkey = '$pkey' and COS_pkey = '$_'")) {
               SarkSubs::SQLiteDo($dbh, "INSERT INTO IPphoneCOSopen  (IPphone_pkey,COS_pkey) VALUES ('$pkey','$_')" );
        }
    }
    foreach ( $_POST['closedcos'] as $ccos ) {
#    	print STDERR "@closedcos element is $_ \n";
    	unless (SarkSubs::SQLiteGet($dbh, "SELECT IPphone_pkey FROM IPphoneCOSclosed where IPphone_pkey = '$pkey' and COS_pkey = '$_'")) {
               SarkSubs::SQLiteDo($dbh, "INSERT INTO IPphoneCOSclosed  (IPphone_pkey,COS_pkey) VALUES ('$pkey','$_')" );
        }
    }

*/ 
}

private function xRef($pkey) {
/*
 * Build Xrefs
 */
	$xref = '';
	$tref = '';
	$sql = "SELECT * FROM IPphone WHERE dvrvmail LIKE '" . $pkey . "' AND pkey !=  '" . $pkey . "' ORDER BY pkey";
	foreach ($this->dbh->query($sql) as $row) {
//		if (!$row == $pkey) {
//			if (!$row['dvrvmail'] == $pkey) {
				$tref .= "This extension provides a voicemailbox for $pkey<br>" . PHP_EOL;
//			}
//		}
	}
	if ($tref != "") {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No other extensions reference this extension's voicemail box<br/>" . PHP_EOL;
    }
    
	$sql = "SELECT * FROM lineio WHERE openroute LIKE '" . $pkey . "' OR closeroute LIKE '" . $pkey . "' ORDER BY pkey";
	foreach ($this->dbh->query($sql) as $row) {
		if ( $row['openroute'] == $pkey || $row['closeroute'] == $pkey ) {
                $tref .= "Trunk " . $row['pkey'] . " references this extension <br>" . PHP_EOL;
        }
	}
	if ($tref != "") {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No Trunks reference this extension<br/>" . PHP_EOL;
    }  
    
 	$sql = "SELECT * FROM speed WHERE outcome LIKE '" . $pkey . "' OR out LIKE '" . $pkey . "' ORDER BY pkey";
 	foreach ($this->dbh->query($sql) as $row) {
		if ($row['pkey'] != 'RINGALL') {
			$tref .= "callgroup " . $row['pkey'] . " references this extension <br>" . PHP_EOL;
		}
	}
	
	if ($tref != "") {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No callgroups reference this extension<br/>" . PHP_EOL;
    }       

	$sql = "SELECT * FROM appl WHERE extcode LIKE '" . $pkey . "' ORDER BY pkey";
	foreach ($this->dbh->query($sql) as $row) {
/*
		$extcode = $row['extcode'];
		if (preg_match( "/$extcode/",$pkey)) {
*/
			$tref .= "App " . $row['pkey'] . " references this extension <br>" . PHP_EOL;
//        }
	}
	if ($tref != "") {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No Apps reference this extension<br/>" . PHP_EOL;
    }  

	$sql = "SELECT * FROM ivrmenu ORDER BY pkey";
	foreach ($this->dbh->query($sql) as $row) {
		if ($row['timeout'] == $pkey) {
			$tref .= "IVR Timeout " . $row['pkey'] . " references this extension <br>" . PHP_EOL;
		}
		else {
			for ($i = 1; $i <= 11; $i++) {
				if ($row["option" . $i] == $pkey) {
					$tref .=  "IVR " . $row['pkey'] . " references this extension <br>" . PHP_EOL;
					break 1;
				}
			}
		}
	}
	if ($tref != "") {
    	$xref .= $tref;
        $tref = "";
    }
    else {
    	$xref .= "No IVRs reference this extension<br/>" . PHP_EOL;
    } 
    return $xref;  		   				
}

private function sipNotify () {
/*
 * send a notify to a phone to reboot it
 */ 
 
    	$pkey = $_GET['pkey'];

		$res = $this->dbh->query("SELECT technology,device  FROM IPphone WHERE pkey ='" . $pkey . "'" )->fetch(PDO::FETCH_ASSOC);
		
		if ($res['technology'] != 'SIP') {
			$this->message = "Ext " . $pkey . " is not a SIP UA!!.";
			return;
		}
#
#	figure out what it is 
#
		$chk = false;
		if (preg_match ( " /Aastra/ ", $res['device'])) {
			$chk = 'aastra-check-cfg';
		}
		if (preg_match ( " /Linksys/ ", $res['device'])) {	
			$chk = 'sipura-check-cfg';
		}
		if (preg_match ( " /Cisco/ ", $res['device'])) {	
			$chk = 'cisco-check-cfg';
		}		
		if (preg_match ( " /Polycom/ ", $res['device'])) {	
			$chk = 'polycom-check-cfg';
		}	
		if (preg_match ( " /Snom/ ", $res['device'])) {
			$chk = 'snom-reboot';
		}
		if (preg_match ( " /Yealink/ ", $res['device'])) {
			$chk = 'yealink-reboot';
		}
		if (preg_match ( " /Grandstream/ ", $res['device'])) {
			$chk = 'grandstream-check-cfg';
		}
		if ( ! $chk ) {
			$this->message = "No notify data available for ext $pkey ";
			return;
		}
		if ( $warp ) {
			$this->helper->request_syscmd ("/bin/asterisk -rx 'sip notify $chk $pkey' ");
		}
		else {
			$this->helper->request_syscmd ("/usr/sbin/asterisk -rx 'sip notify $chk $pkey' ");
    		}
    	$this->message = "Issued SIP Notify to Ext " . $pkey . "(" . $res['device'] . ")" ;
}

private function build_peer_array($amirets) {
/*
 * build an array of peers by cleaning up the AMI output
 * (which contains stuff we don't want).
 */ 
	$lines = explode("\r\n",$amirets);	
	$peer = 0;
	foreach ($lines as $line) {
		// ignore lines that aren't couplets
		if (!preg_match(' /:/ ',$line)) { 
				continue;
		}
		
		// parse the couplet	
		$couplet = explode(': ', $line);
		
		// ignore events and ListItems
		if ($couplet[0] == 'Event' || $couplet[0] == 'ListItems') {
			continue;
		}
		
		//check for a new peer and set a new key if we have one
		if ($couplet[0] == 'ObjectName') {
			preg_match(' /^(.*)\// ',$couplet[1],$matches);
			if (isset($matches[1])) {
				$peer = $matches[1];
			}
			else {
				$peer = $couplet[1];
			}
		}
		else {
			if (!$peer) {
				continue;
			}
			else {
				$peer_array [$peer][$couplet[0]] = $couplet[1];
			}
		}
	}
	return $peer_array;	
}
}
