
  $(document).ready(function() {
	  
	$('#pagetabs').tabs();
	toggleDhcpStatus();
	      
	$.validator.addMethod("ipcheck",function(value,element) {
		return this.optional(element) || /^(\d|[1-9]\d|1\d\d|2([0-4]\d|5[0-5]))\.(\d|[1-9]\d|1\d\d|2([0-4]\d|5[0-5]))\.(\d|[1-9]\d|1\d\d|2([0-4]\d|5[0-5]))\.(\d|[1-9]\d|1\d\d|2([0-4]\d|5[0-5]))/.test(value); 
	},"This ip address or netmask looks wrong");
	
	$.validator.addMethod("domaincheck",function(value,element) {
		return this.optional(element) || /^([\da-z\.-]+)\.([a-z\.]{2,6})$/i.test(value); 
	},"This domain looks wrong");	
	
	$.validator.addMethod("hostcheck",function(value,element) {
		return this.optional(element) || /^[a-z0-9][a-z0-9-]{2,63}$/i.test(value); 
	},"This hostname looks wrong");		
	  
	$("#sarknetworkForm").validate ( {
	   rules: {
			ipaddr: "ipcheck",
			netmask: "ipcheck", 
			gatewayip: "ipcheck",  
			domain: "domaincheck",
			dns1: "ipcheck",
			dns2: "ipcheck",
			sshport: {required: true, range:[1,65535]},
			localhost: "required hostcheck"
	   },
	   messages: {
		   sshport: "1-65535 please"
	   }					
	}); 
 });
 
 function toggleDhcpStatus() {
    if ($('#toggleDhcpElement').is(':checked')) {
        $('#elementsToOperateOnDhcp :input').attr('disabled', true);
        $('#elementsToOperateOnDhcp :input').css('background-color','lightgrey');
    } else {
        $('#elementsToOperateOnDhcp :input').removeAttr('disabled');
        $('#elementsToOperateOnDhcp :input').css('background-color','white');
    }
}
 

      
