<?php
//
// Developed by CoCo
// Copyright (C) 2012 CoCoSoft
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public Licenseinterfaces
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
require_once "../srkPageClass";
require_once "../srkDbClass";
require_once "../srkHelperClass";
require_once "../formvalidator.php";
require_once 'Net/IPv4.php';


Class network {
	
	protected $message; 
	protected $myPanel;
	protected $dbh;
	protected $helper;
	protected $validator;
	protected $invalidForm;
	protected $error_hash = array();
	
public function showForm() {
	
	$this->myPanel = new page;
	$this->dbh = DB::getInstance();
	$this->helper = new helper;
		
	echo '<body>';
	echo '<form id="sarknetworkForm" action="' . $_SERVER['PHP_SELF'] . '" method="post">' . PHP_EOL;
	
	$this->myPanel->pagename = 'Network Settings';
	
	if (isset($_POST['save_x'])) { 
		$this->saveEdit();
		if ($this->invalidForm) {
			$this->showMain();
			return;
		}					
	}
	if (isset($_POST['reboot_x'])) { 
		$this->saveEdit();
		if ($this->invalidForm) {
			$this->showMain();
			return;
		}
		else {
			$this->helper->request_syscmd ("reboot");
			$this->message = "Rebooting Now, Please wait...";
			$this->showMain();
			return;
		}
	}	
				
	$this->showMain();
	
	$this->dbh = NULL;
	return;
	
}
	
private function showMain() {
	
	if (isset($this->message)) {
		$this->myPanel->msg = $this->message;
	} 
	$dhcp=false;
	if (` grep eth0 /etc/network/interfaces | grep -i dhcp` ) {
		$dhcp=true;
	}
	$arch = trim(`/bin/uname -m`);
	
	$ret = $this->helper->request_syscmd ("ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'");
	$ipaddr = preg_replace('/<<EOT>>$/', '', $ret);	
	$ret = $this->helper->request_syscmd ("ifconfig eth0 | grep 'inet addr:' | cut -d: -f4 | awk '{ print $1}'");
	$netmask = preg_replace('/<<EOT>>$/', '', $ret);
	$ret = $this->helper->request_syscmd ("ip route | grep default | cut -d' ' -f3 | awk '{ print $1}'");
	$gatewayip = preg_replace('/<<EOT>>$/', '', $ret);		

	$hostname = `cat /etc/hostname`;
	
	$file = file("/etc/ntp.conf") or die("Could not read file ntp.conf!");	
	$astfile = null;
	foreach ($file as $rec) {
		if ( preg_match (" /^server\s*(.*)$/ ",$rec,$matches)) {
			$astfile .=  $matches[1]."\n";
		}
	}	
	
	$ret = $this->helper->request_syscmd ("grep Port /etc/ssh/sshd_config");
	$ret = preg_replace('/<<EOT>>$/', '', $ret);
	if (preg_match (" /(\d{2,5})/ ",$ret,$matches)) {
			$sshport=$matches[1];
	}
	else {
			$sshport = 22;
	} 
	
	$file = file("/etc/ssmtp/ssmtp.conf") or die("Could not read file ssmtp.conf!");	
	$ntpservers = array();
	foreach ($file as $rec) {
		if ( preg_match (" /^AuthUser=\s*(.*)$/ ",$rec,$matches)) {
			$smtpuser =  $matches[1];
		}
		if ( preg_match (" /^AuthPass=\s*(.*)$/ ",$rec,$matches)) {
			$smtppwd =  $matches[1];
		}
		if ( preg_match (" /^mailhub=\s*(.*)$/ ",$rec,$matches)) {
			$smtphost =  $matches[1];
		}		
	}
	
	$dns = array();
	$handle = fopen("/etc/resolv.conf", "r") or die('Could not read resolv.conf!');
	while (!feof($handle)) {
		$buff = fgets($handle);
		if (preg_match (" /^domain\s*(.*)$/ ",$buff,$matches)) {	
			$domain = $matches[1];
		}
		if (preg_match (" /^search\s*(.*)$/ ",$buff,$matches)) {	
			$searchdomain = $matches[1];
		}			
		if (preg_match (" /^nameserver\s*(.*)$/ ",$buff,$matches)) {
			array_push ($dns, $matches[1]);
		}
		if (count($dns) == 2) {
			break;
		}
	}
	fclose($handle);

/* 
 * start page output
 */
  
	echo '<div class="buttons">' . PHP_EOL;
    $this->myPanel->Button("save");
	$this->myPanel->Button("reboot");
	echo '</div>' . PHP_EOL;	
	
	$this->myPanel->Heading();
	if (isset($this->message)) {
		foreach ($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}

    echo '<br/>';
    
	echo '<div id="pagetabs"  class="ui-tabs">' . PHP_EOL;
    echo '<ul>'.  PHP_EOL;

    if ( substr($arch, 0, 3) == 'arm' || $arch == 'ppc') { 
		echo '<li><a href="#network">Network</a></li>'. PHP_EOL;
	}
    echo '<li><a href="#smtp">SMTP</a></li>'. PHP_EOL;
    echo '<li><a href="#ntp">NTP</a></li>'. PHP_EOL;
    
    echo '</ul>'. PHP_EOL;
    


	if ( substr($arch, 0, 3) == 'arm' || $arch == 'ppc') { 
		echo '<div id="network" class="ui-tabs-hide">'. PHP_EOL;
	
	
		if ( $dhcp ) {
		echo "<span style = \"font-size:normal; font-weight:bold; color: #666666;\">Use DHCP to obtain an IP address?:</span> <input id=\"toggleDhcpElement\" type=\"checkbox\" name=\"toggle\" checked=\"checked\" onchange=\"toggleDhcpStatus()\"  /></strong>";
		}
		else {
			echo "<span style = \"font-size:normal; font-weight:bold; color: #666666;\">Use DHCP to obtain an IP address?:</span> <input id=\"toggleDhcpElement\" type=\"checkbox\" name=\"toggle\" onchange=\"toggleDhcpStatus()\"  /></strong>";
		}
    
		echo '<div id="elementsToOperateOnDhcp">';
    
		$this->myPanel->aLabelFor('ipaddr');
		echo '<input type="text" name="ipaddr" id="ipaddr" size="20"  value="' . $ipaddr . '"  />' . PHP_EOL;
		$this->myPanel->aLabelFor('netmask');
		echo '<input type="text" name="netmask" id="netmask" size="20"  value="' . $netmask . '"  />' . PHP_EOL;
		$this->myPanel->aLabelFor('gatewayip');
		echo '<input type="text" name="gatewayip" id="gatewayip" size="20"  value="' . $gatewayip. '"  />' . PHP_EOL;
		$this->myPanel->aLabelFor('domain');
		echo '<input type="text" name="domain" id="domain" size="30"  value="' . $domain . '"  />' . PHP_EOL;		
		$this->myPanel->aLabelFor('dns');	
		echo '<input type="text" name="dns1" id="dns1" size="20"  value="' . $dns[0] . '"  />' . PHP_EOL;
		$this->myPanel->aLabelFor('dns');
		echo '<input type="text" name="dns2" id="dns2" size="20"  value="' . $dns[1] . '"  />' . PHP_EOL;    
		echo '<br/><br/>' . PHP_EOL; 	
		echo "</div>". PHP_EOL;
		
		$this->myPanel->aLabelFor('localhost');
		echo '<input type="text" name="hostname" id="hostname" size="20"  value="' . $hostname . '"  />' . PHP_EOL;

		$this->myPanel->aLabelFor('sshport');    
		echo '<input type="text" name="sshport" id="sshport" size="5"  value="' . $sshport . '"  />' . PHP_EOL; 
		echo '<br/><br/>' . PHP_EOL; 

	
/*
 *      TAB DIVEND
 */
		echo "</div>". PHP_EOL;
	}
/*
 *  SMTP
 */     
	echo '<div id="smtp" class="ui-tabs-hide">'. PHP_EOL;
    $this->myPanel->aLabelFor('smtphost');    
    echo '<input type="text" name="smtphost" id="smtpip" size="20"  value="' . $smtphost . '"  />' . PHP_EOL; 
    $this->myPanel->aLabelFor('user');    
    echo '<input type="text" name="smtpuser" id="smtpuser" size="20"  value="' . $smtpuser . '"  />' . PHP_EOL;    
    $this->myPanel->aLabelFor('password');    
    echo '<input type="text" name="smtppwd" id="smtppwd" size="20"  value=""  />' . PHP_EOL; 
/*
 *      TAB DIVEND
 */
    echo "</div>". PHP_EOL;
/*
 *  NTP
 */    
	echo '<div id="ntp" class="ui-tabs-hide">'. PHP_EOL;
	echo '<strong>NTP Servers</strong><br/><br/>';
	echo '<textarea rows="7" cols="50" name="astfile" id="astfile">' . $astfile . '</textarea>' . PHP_EOL;  
/*
 *      TAB DIVEND
 */
    echo "</div>". PHP_EOL;    
/*
 *  end of TABS DIV
 */ 
    echo '</div>' . PHP_EOL;
}


private function saveEdit() {
// save the data away

	$network_string = "auto lo eth0\niface lo inet loopback\n";	
	$dhcp_on_string = 
		"iface eth0 inet dhcp\n".
		"allow-hotplug wlan0\n". 
		"iface wlan0 inet manual\n". 
		"wpa-roam /etc/wpa_supplicant.conf\n". 
		"iface default inet dhcp\n";

	$cur_dhcp=false;
	if (` grep eth0 /etc/network/interfaces | grep -i dhcp` ) {
		$cur_dhcp=true;
	}	

	$this->validator = new FormValidator();

	$this->validator->addValidation("sshpport","num","sshport must be numeric"); 
	$this->validator->addValidation("sshport","maxlen=5","sshport max length is 5"); 
    $this->validator->addValidation("smtpuser","alphanum","smtpuser must be alphanumeric");    
	$this->validator->addValidation("hostname","alphanum","hostname must be alphanumeric");
	
	if ( !isset($_POST['toggle'] ) ) {
		$this->validator->addValidation("ipaddr","req","You MUST provide an ip address");
		$this->validator->addValidation("netmask","req","You MUST provide a network mask");
		$this->validator->addValidation("gatewayip","req","You MUST provide a gateway address");
		$this->validator->addValidation("dns1","req","You MUST provide at least one nameserver for correct execution of the PBX");
	}
	 	
    $this->validator->addValidation("ipaddr",
		"regexp=/^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])$/",
		"IP address is invalid");
    $this->validator->addValidation("netmask",
		"regexp=/^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])$/",
		"Netmask is invalid");
	$this->validator->addValidation("gatewayip",
		"regexp=/^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])$/",
		"Gateway IP address is invalid");	
	$this->validator->addValidation("domain",
		"regexp=/^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$/",
		"Domain is invalid");		
	
	//Now, validate the form
    if ($this->validator->ValidateForm()) {
		
		$ipaddr			= strip_tags($_POST['ipaddr']);	
		$netmask		= strip_tags($_POST['netmask']);
		$gatewayip		= strip_tags($_POST['gatewayip']);
		$hostname 		= strip_tags($_POST['hostname']);	
		$domain 		= strip_tags($_POST['domain']);			
		$sshport		= strip_tags($_POST['sshport']);
		$smtpuser		= strip_tags($_POST['smtpuser']);
		$smtppwd		= strip_tags($_POST['smtppwd']);
		$smtphost		= strip_tags($_POST['smtphost']);
		$astfile		= strip_tags($_POST['astfile']);
		$dns1			= strip_tags($_POST['dns1']);
		$dns2			= strip_tags($_POST['dns2']);

						
		$ret = $this->helper->request_syscmd ("ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'");
		$cur_ipaddr = preg_replace('/<<EOT>>$/', '', $ret);	
		$ret = $this->helper->request_syscmd ("ifconfig eth0 | grep 'inet addr:' | cut -d: -f4 | awk '{ print $1}'");
		$cur_netmask = preg_replace('/<<EOT>>$/', '', $ret);
		$ret = $this->helper->request_syscmd ("ip route | grep default | cut -d' ' -f3 | awk '{ print $1}'");
		$cur_gatewayip = preg_replace('/<<EOT>>$/', '', $ret);		

		$cur_hostname = `hostname`;
		$cur_domain = `hostname -d`;
	
		$file = file("/etc/ntp.conf") or die("Could not read file $pkey !");	
		$cur_astfile = null;
		foreach ($file as $rec) {
			if ( preg_match (" /^server\s*(.*)$/ ",$rec,$matches)) {
				$cur_astfile .=  $matches[1]."\n";
			}
		}		
	
		$ret = $this->helper->request_syscmd ("grep Port /etc/ssh/sshd_config");
		$ret = preg_replace('/<<EOT>>$/', '', $ret);
		if (preg_match (" /(\d{2,5})/ ",$ret,$matches)) {
			$cur_sshport=$matches[1];
		}
		else {
			$cur_sshport = 22;
		} 
	

/*
 * update the files
 */ 

		$ret='OK';
		$reboot=false;
		if (isset($hostname) && $hostname != $cur_hostname) {
				$myret = $this->helper->request_syscmd ("/bin/echo ".$hostname." > /etc/hostname");
				$reboot=true;
		}
		
		if ($cur_sshport != $sshport) {
			$myret=$this->helper->request_syscmd ("/bin/sed -i 's/^Port [0-9][0-9]*/Port $sshport/' /etc/ssh/sshd_config");
//			$myret=$this->helper->request_syscmd ("/usr/sbin/service ssh restart");
		}	
		
		$rewrite = false;
		if ( isset($_POST['toggle']) ) {
			if (!$cur_dhcp) {			
				$network_string .= $dhcp_on_string;
				$rewrite = true;
			}
		}
		else {
			$ip_calc = new Net_IPv4();
			$ip_calc->ip = $ipaddr;
			$ip_calc->netmask = $netmask;
			$ipcalcret = $ip_calc->calculate();
			if (is_object($ipcalcret)) {
				die ("IP Calc failed");
			}					
			$network_string .= "iface eth0 inet static \n";
			$network_string .= "\taddress " . $ipaddr . "\n";
			$network_string .= "\tnetmask " . $netmask . "\n";
			$network_string .= "\tbroadcast " . $ip_calc->broadcast . "\n";
			$network_string .= "\tgateway " . $gatewayip . "\n";	
			$rewrite = true;
			$this->helper->request_syscmd ("tail  /etc/resolv.conf > /etc/resolv.conf");	
			if ($domain) {				
				$this->helper->request_syscmd ("echo domain $domain >> /etc/resolv.conf");
			}
			if ($dns1) {
				$this->helper->request_syscmd ("echo nameserver $dns1 >> /etc/resolv.conf");
			}
			if ($dns2) {
				$this->helper->request_syscmd ("echo nameserver $dns2 >> /etc/resolv.conf");
			}									
		}

				
		$file = file("/etc/ssmtp/ssmtp.conf") or die("Could not read file ssmtp.conf!");	
		foreach ($file as $rec) {
			if ( preg_match (" /^AuthUser=\s*(.*)$/ ",$rec,$matches)) {
				$cur_smtpuser =  $matches[1];
			}
			if ( preg_match (" /^AuthPass=\s*(.*)$/ ",$rec,$matches)) {
				$cur_smtppwd =  $matches[1];
			}
			if ( preg_match (" /^mailhub=\s*(.*)$/ ",$rec,$matches)) {
				$cur_smtphost =  $matches[1];
			}		
		}
		if ( isset ($_POST['smtpuser']) && $smtpuser != $cur_smtpuser) {
			$myret=$this->helper->request_syscmd ("sed -i 's/^AuthUser=.*/AuthUser=$smtpuser/' /etc/ssmtp/ssmtp.conf");
		}
		if ( isset ($_POST['smtphost']) && $smtphost != $cur_smtphost) {
			$myret=$this->helper->request_syscmd ("sed -i 's/^mailhub=.*/mailhub=$smtphost/' /etc/ssmtp/ssmtp.conf");
		}		
		if ( isset ($_POST['smtppwd']) && $smtppwd && $smtppwd != $cur_smtppwd) {
			$myret=$this->helper->request_syscmd ("sed -i 's/^AuthPass=.*/AuthPass=$smtppwd/' /etc/ssmtp/ssmtp.conf");
		}	
		$myret=$this->helper->request_syscmd ("sed -i 's/^hostname=.*/hostname=$hostname.$domain/' /etc/ssmtp/ssmtp.conf");
		
		$ntpservers = explode("\n", $astfile);
		if (!empty($ntpservers)) {
			$this->helper->request_syscmd ("sed -i '/^server/d' /etc/ntp.conf");
			foreach ($ntpservers as $ntp) {
				if ($ntp) {
					$trimntp = trim($ntp);
					$this->helper->request_syscmd ("echo server $trimntp >> /etc/ntp.conf");
				}
			}
		}
				 		
		if ($rewrite) {
			$myret = $this->helper->request_syscmd ("chmod 777 /etc/network/interfaces");
			$fh = fopen("/etc/network/interfaces", 'w') or die('Could not open interface file!');
			fwrite($fh, $network_string) or die('Could not write to file');
			fclose($fh);
			$myret = $this->helper->request_syscmd ("chmod 644 /etc/network/interfaces"); 
			echo "<strong> Resetting IP address now...</strong>";			
			$myret = $this->helper->request_syscmd ("ifdown eth0 && ifup eth0");
			return;
		}	
				
/*
 * flag errors
 */ 	
		if ($ret == 'OK') {
			$this->message = "Updated Networks (you may need to reboot)!";
		}
		else {
			$this->invalidForm = True;
			$this->message = "<B>  --  Validation Errors!</B>";	
			$this->error_hash[speed] = $ret;	
		}			
	}
    else {
		$this->invalidForm = True;
		$this->error_hash = $this->validator->GetErrors();
		$this->message = "<B>  --  Validation Errors!</B>";		
    }
    unset ($this->validator);
}



}
