<?php
// sarkuser class
// Developed by CoCo
// Copyright (C) 2012 CoCoSoFt
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
require_once "../srkPageClass";

Class passwd {
	
	protected $message; 
	protected $myPanel;
	protected $dbh;
	protected $helper;
	protected $validator;
	protected $invalidForm;
	protected $error_hash = array();
	
public function showForm() {

	$this->myPanel = new page;
		
	echo '<body>';	
	echo '<form id="sarkpasswdForm" action="' . $_SERVER['PHP_SELF'] . '" method="post">';
	
	$this->myPanel->pagename = 'Password change';
	
	if (isset($_POST['save_x'])) { 
		$this->saveNew();		
	}
	
	$this->showMain();
	
	return;		
}


private function showMain() {

	if (isset($this->message)) {
		$this->myPanel->msg = $this->message;
	} 
	echo '<div class="buttons">';	
	$this->myPanel->Button("save");
	echo '</div>';
		
	$this->myPanel->Heading();
	if (isset($this->message)) {
		foreach ($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}	

	echo <<< NEW_FORM
	<br/>
	<br/>
	<div>
    <div class="notes"
    <h4>Passwords</h4>
    <p class=\"last\">Choose a strong, memorable, password; it should have a mix of upper and lowercase letters and numbers and be
	at least 8 characters in length. Try to avoid the more unusual special characters which may not always appear in the same place 
	on all keyboards. <br/> This panel changes only the SARK browser admin password. To change the root password you must use the CLI </p>
    </div>	
	<br/>
	<br/>
	<br/>
	<div >
	<DL>
		<DT style="font-weight:bold" > Current Password : 
 		<DD><INPUT TYPE=PASSWORD NAME="password">
		<br><br>
		<DT style="font-weight:bold" > New Password: 
 		<DD><INPUT TYPE=PASSWORD NAME="newpass">
		<br><br>
		<DT style="font-weight:bold" > Confirm New Password: 
 		<DD><INPUT TYPE=PASSWORD NAME="newpass2">
	</DL>
	</div>
	</div>
NEW_FORM;
			
}

private function saveNew() {
	
	$record = array();
    if ( $warp ) {
		$pfile = "/opt/sark/passwd/ltpasswds";
	}
	else {
		$pfile = "/opt/sark/passwd/htpasswd";
	}
	$row = false;
	$handle = fopen($pfile, "r") or die('Could not read file!');
	while (!feof($handle)) {
		$row = fgets($handle);
		array_push($record,trim($row));
	}
	fclose($handle);
	$i = 0;
	
	while ($i < sizeof($record)) {
		$pos = strpos($record[$i], $_SERVER['REMOTE_USER']);
		if ($pos === false) {
			$i++;
		}
		else {
			$splits = explode(':',$record[$i]);
			break;
		}
	}

	if ($pos === false) {
		$this->invalidForm = True;
		$this->message = "<B>  --  Validation Errors!</B>";	
		$this->error_hash['user'] = "ERROR! - USER does not exist!!";
		return ;
	}
	
	$salt = substr($splits[1],0,2);
	
    $cp = crypt ( $_POST['password'],$salt );
    
    if ( ! empty($_POST['password']) ) {
		if ( ! empty($_POST['newpass']) ) { 
    		if ( $_POST['newpass'] == $_POST['newpass2'] ) {
				if ( preg_match ( ' /(?=^.{8,}$)/ ',  $_POST['newpass'] )) {
    				if ( $cp == $splits[1]  ) {
						$record[$i] = $splits[0] . ':' . crypt ( $_POST['newpass'], $_POST['newpass'] )."\n";
						$this->message = "Password successfully changed";	
					}
					else {
						$this->invalidForm = True;
						$this->message = "<B>  --  Validation Errors!</B>";					
						$this->error_hash['user'] = "Old Password incorrect!";
					}
				}
				else {
					$this->invalidForm = True;
					$this->message = "<B>  --  Validation Errors!</B>";
					$this->error_hash['user'] = "Password must contain 8 characters!";
				}	
    		}
    		else {
				$this->invalidForm = True;
				$this->message = "<B>  --  Validation Errors!</B>";
    			$this->error_hash['user'] = "New Passwords do not match!";
    		}
		}
		else {
			$this->invalidForm = True;
			$this->message = "<B>  --  Validation Errors!</B>";
			$this->error_hash['user'] = "New Password not entered!";
		}
    }
    else {
		$this->invalidForm = True;
		$this->message = "<B>  --  Validation Errors!</B>";
		$this->error_hash['user'] = "Password not entered!";
    }
	if ( ! $this->invalidForm ) { 
		$fh = fopen($pfile, 'wb') or die('Could not open htpasswd');
		foreach ($record as $row) {
			fwrite($fh,$row);
		}
		fclose($fh);
	}

}

}
