<?php
//
// Developed by CoCo
// Copyright (C) 2012 CoCoSoft
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
require_once "../srkPageClass";
require_once "../srkDbClass";
require_once "../srkHelperClass";
require_once "../formvalidator.php";


Class queue {
	
	protected $message; 
	protected $myPanel;
	protected $dbh;
	protected $helper;
	protected $validator;
	protected $invalidForm;
	protected $error_hash = array();
	
public function showForm() {
	
	$this->myPanel = new page;
	$this->dbh = DB::getInstance();
	$this->helper = new helper;
		
	echo '<body>';
	echo '<form id="sarkqueueForm" action="' . $_SERVER['PHP_SELF'] . '" method="post">' . PHP_EOL;
	
	$this->myPanel->pagename = 'Queues';
	
	if (isset($_POST['new_x'])) { 
		$this->saveNew();
	}
	
	if (isset($_GET['edit'])) { 
		$this->showEdit();	
		return;
	}	
	

	if (isset($_POST['save_x'])) { 
		$this->saveNew();
		if ($this->invalidForm) {
			$this->showNew();
			return;
		}					
	}
	
	if (isset($_POST['update_x'])) { 
		$this->saveEdit();
		if ($this->invalidForm) {
			$this->showEdit();
			return;
		}					
	}

	if (isset($_POST['commit_x']) || isset($_POST['commitClick_x'])) { 
		$this->helper->sysCommit();
		$this->message = "Updates have been Committed";	
	}
		
	$this->showMain();
	
	$this->dbh = NULL;
	return;
	
}
	
private function showMain() {
	
	if (isset($this->message)) {
		$this->myPanel->msg = $this->message;
	} 

/* 
 * start page output
 */
  
	echo '<div class="buttons">';	
	$this->myPanel->Button("new");
	$this->myPanel->commitButton();
	echo '</div>';	
	
	$this->myPanel->Heading();
	
	$tabname = 'queuetable';
	if ( $_SERVER['REMOTE_USER'] == 'admin' ) {
		$tabname .= 'admin';
	}
	echo '<table cellpadding="0" cellspacing="0" border="0" class="display" width="70%" id="' . $tabname . '"  >' ;	


	echo '<thead>' . PHP_EOL;	
	echo '<tr>' . PHP_EOL;
	

	$this->myPanel->aHeaderFor('queuename');
	$this->myPanel->aHeaderFor('cluster'); 	
	$this->myPanel->aHeaderFor('queueoptions');
	$this->myPanel->aHeaderFor('devicerec');

	echo '<th class="srk-border" style="color:#ffffff">Edit</th>' . PHP_EOL;   // edit 
	echo '<th class="srk-border" style="color:#ffffff">Del</th>' . PHP_EOL;    // Del
	
	echo '</tr>' . PHP_EOL;
	echo '</thead>' . PHP_EOL;
	echo '<tbody>' . PHP_EOL;
		
/*** table rows ****/

	$rows = $this->helper->getTable("queue");
	foreach ($rows as $row ) { 
		echo '<tr id="' . $row['pkey'] . '">'. PHP_EOL; 
		echo '<td class="read_only">' . $row['pkey'] . '</td>' . PHP_EOL;			
		echo '<td >' . $row['cluster']  . '</td>' . PHP_EOL;		 
		echo '<td >' . $row['options']  . '</td>' . PHP_EOL;	
		echo '<td >' . $row['devicerec']  . '</td>' . PHP_EOL;	
		$get = '?edit=yes&amp;pkey=';
		$get .= $row['pkey'];	
		$this->myPanel->editClick($_SERVER['PHP_SELF'],$get);

		echo '<td ><a class="table-action-deletelink" href="/php/sarkqueue/delete.php?id=' . $row['pkey'] . '"><img src="/sark-common/edittrash.png" border=0 title = "Click to Delete" ></a></td>' . PHP_EOL;				
		echo '</td>' . PHP_EOL;
		echo '</tr>'. PHP_EOL;
	}

	echo '</tbody>' . PHP_EOL;
	echo '</table>' . PHP_EOL;
		
}

private function saveNew() {
// save the data away
	
	$tuple = array();

	$tuple['pkey'] 	= '000-New' . rand(1000, 9999);

	$ret = $this->helper->createTuple("queue",$tuple);
	if ($ret == 'OK') {
		$this->message = "Created new Queue " . $tuple['pkey'] . "!";
	}
	else {
		$this->invalidForm = True;
		$this->message = "<B>  --  Validation Errors!</B>";	
		$this->error_hash['exteninsert'] = $ret;	
	}
	
}

private function showEdit() {
	
	$pkey = $_GET['pkey']; 
	$queue = $this->dbh->query("SELECT * FROM queue WHERE pkey = '" . $pkey . "'")->fetch(PDO::FETCH_ASSOC);

	$printline = "Queue " . $pkey;
	$this->myPanel->msg .= $printline; 
	
	if (isset($this->message)) {
		$this->myPanel->msg .= $this->message;
	} 

	echo '<div class="buttons">';
	$this->myPanel->Button("cancel");
	$this->myPanel->override="update";
	$this->myPanel->Button("save");
	echo '</div>';	
		
	$this->myPanel->Heading();
	if (isset($this->message)) {	
		foreach($this->error_hash as $inpname => $inp_err) {
			echo "<p>$inpname : $inp_err</p>\n";
		}       
	}	
	echo '<br/>'. PHP_EOL;		
	echo '<br/><span style="color: rgb(0, 0, 0); font-weight:bold;font-size:small;" >Queue Name </span></span>';
	echo '<input type="text" name="newkey" size="20" id="newkey" value="' . $pkey . '"  />' . PHP_EOL;	
	echo '<br/><br/>'. PHP_EOL;
	echo '<textarea rows="20" cols="80" name="conf" id="conf">' . $queue['conf'] . '</textarea>' . PHP_EOL;
	echo '<input type="hidden" name="pkey" id="pkey" value="' . $queue['pkey'] . '"  />' . PHP_EOL; 
			
}

private function saveEdit() {
// save the data away
//print_r ($_POST) . "\n";

	$tuple = array();
		
	$this->validator = new FormValidator();

    //Now, validate the form
    if ($this->validator->ValidateForm()) {
/*
 * 	call the tuple builder to create a table row array 
 */  	
		$custom = array (
						'newkey' => True
        );

		$this->helper->buildTupleArray($_POST,$tuple,$custom);

/*
 * update the SQL database
 */
 
// remove any escaped quotes 			
		$tuple['conf'] = preg_replace ( "/\\\/", '', $tuple['conf']);
		
		if (isset($_POST['newkey'])) {
			$newkey =  trim(strip_tags($_POST['newkey']));
		}
		
		if ($newkey && $newkey != $tuple['pkey']) {	
			$ret = $this->helper->setTuple("queue",$tuple,$newkey);
		}
		else {
			$ret = $this->helper->setTuple("queue",$tuple);
		}			 
		if ($ret == 'OK') {
//			$this->helper->commitOn();	
			$this->message = "Updated queue ";
		}
		else {
			$this->invalidForm = True;
			$this->message = "<B>  --  Validation Errors!</B>";	
			$this->error_hash['extensave'] = $ret;	
		}			
	}
    else {
		$this->invalidForm = True;
		$this->error_hash = $this->validator->GetErrors();
		$this->message = "<B>  --  Validation Errors!</B>";		
    }
    unset ($this->validator);
}


}
