
  $(document).ready(function() {
	  
	$.validator.addMethod("dplan",function(value,element) {
		return this.optional(element) || /^[0-9_NXZ.*#\/]+$/i.test(value); 
	},"field can only contain _0-9NXZ.*#/");	
	  
	$("#sarkrouteForm").validate ( {
	   rules: {
			pkey: "required",
			alternate: "digits",	
			dialplan: "dplan"			   
	   },
	   messages: {
		   route: "You must enter the route name",
		   alternate: "specify a phone number with no spaces or leave blank"
	   }					
	});  


	$('#routetable').dataTable ( {
//		"sScrollX": "100%",
		"bInfo": false,
		"bPaginate": true,
		"bLengthChange": false,
		"sDom": '<"top"i>pt<"bottom"f>',
		"aoColumnDefs": [ 
			{ "bSortable": false, "aTargets": [2,5,6,7,8] },
			{ "sClass": 'bluetags', "aTargets": [ 2,3,4,5,6,7 ] }
		],
		"aoColumns": [ 
			{ "sName": "pkey" },
			{ "sName": "cluster" },
			{ "sName": "desc" },
			{ "sName": "dialplan" },
			{ "sName": "path1" },
//			{ "sName": "path2" },
//			{ "sName": "path3" },		   
//			{ "sName": "path4" },			
			{ "sName": "auth" },
			{ "sName": "active" },
			{ "sName": null },
			{ "sName": null }
		] 

	} ).makeEditable({
			sUpdateURL: "/php/sarkroute/update.php",
//			sDeleteURL: "/php/sarkroute/delete.php",
			sReadOnlyCellClass: "read_only",
			"aoColumns": [
				{
					type: 'textarea',
                    onblur: 'cancel',
                    submit: 'Save',
					tooltip: 'Route name',
					placeholder: 'Null'
				},		// pkey
				null,   // tenant
				{
					type: 'textarea',
					submit:'Save',
					tooltip: 'Double Click to set Tenent',
					onblur: 'cancel',	
					placeholder: 'Null',
				},		// description
				{
					type: 'textarea',
                    onblur: 'cancel',
                    submit: 'Save',			
					tooltip: 'Double Click to set dialplan',
					onblur: 'cancel',
					placeholder: 'Null',
				}, 		// dialplan
				{
					type: 'select',
					tooltip: 'Double Click to select path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path1
/*				{
					type: 'select',
					tooltip: 'Double Click to select path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path2
	
				{
					type: 'select',
					tooltip: 'Double Click to set path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
					
				}, 		// path3
				{
					type: 'select',
					tooltip: 'Double Click to set path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path4	
*/							
				{
					tooltip: 'Double Click to set auth',
					type: 'select',
                    onblur: 'cancel',
                    submit: 'Save',
					data: "{ 'YES':'YES','NO':'NO' }",
				}, 		// Auth		
				{
					tooltip: 'Double Click to activate/deactivate',
					type: 'select',
                    onblur: 'cancel',
                    submit: 'Save',
					data: "{ 'YES':'YES','NO':'NO' }",
				}, 		// act
				null,   // edit col
				null	// delete col					
            ]
        });  
        
	$('#routetableadmin').dataTable ( {
//		"sScrollX": "100%",
		"bInfo": false,
		"bPaginate": true,
		"bLengthChange": false,
		"sDom": '<"top"i>pt<"bottom"f>',
		"aoColumnDefs": [ 
			{ "bSortable": false, "aTargets": [2,5,6,7,8] },
			{ "sClass": 'bluetags', "aTargets": [ 2,3,4,5,6,7 ] }
		],
		"aoColumns": [ 
			{ "sName": "pkey" },
			{ "sName": "cluster" },
			{ "sName": "desc" },
			{ "sName": "dialplan" },
			{ "sName": "path1" },
//			{ "sName": "path2" },
//			{ "sName": "path3" },		   
//			{ "sName": "path4" },			
			{ "sName": "auth" },
			{ "sName": "active" },
			{ "sName": null },
			{ "sName": null }
		] 

	} ).makeEditable({
			sUpdateURL: "/php/sarkroute/update.php",
//			sDeleteURL: "/php/sarkroute/delete.php",
			sReadOnlyCellClass: "read_only",
			"aoColumns": [
				{
					type: 'textarea',
					submit:'Save',
					tooltip: 'route name',
					onblur: 'cancel',	
					placeholder: 'Null'
				},		// pkey
				{
					type: 'select',
					tooltip: 'Tenant',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/cluster/list.php',
                    loadtype: 'GET'					
				}, 	// Tenant
				{
					type: 'textarea',
					submit:'Save',
					tooltip: 'Double Click to set desc',
					onblur: 'cancel',	
					placeholder: 'Null',
				},		// description
				{
					type: 'textarea',
					submit:'Save',					
					tooltip: 'Double Click to set dialplan',
					onblur: 'cancel',
					placeholder: 'Null',
				}, 		// dialplan
				{
					type: 'select',
					tooltip: 'Double Click to select path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path1
/*				{
					type: 'select',
					tooltip: 'Double Click to select path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path2
	
				{
					type: 'select',
					tooltip: 'Double Click to set path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
					
				}, 		// path3
				{
					type: 'select',
					tooltip: 'Double Click to set path',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/lineio/listroutes.php',
                    loadtype: 'GET'	
				}, 		// path4	
*/							
				{
					tooltip: 'Double Click to set auth',
					type: 'select',
                    onblur: 'cancel',
                    submit: 'Save',
					data: "{ 'YES':'YES','NO':'NO' }",
				}, 		// Auth		
				{
					tooltip: 'Double Click to activate/deactivate',
					type: 'select',
                    onblur: 'cancel',
                    submit: 'Save',
					data: "{ 'YES':'YES','NO':'NO' }",
				}, 		// act
				null,	// edit col
				null	// delete col					
            ]
        });          
      });
      
