
  $(document).ready(function() {
	  
	$('#pagetabs').tabs();  
	
	$.validator.addMethod("xform",function(value,element) {
		return this.optional(element) || /^[0-9#*+: ]+$/i.test(value); 
	},"Mask can only contain 0-9#*+: and space characters");
	
	$.validator.addMethod("dialplan",function(value,element) {
		return this.optional(element) || /^[0-9_NXZ.*#\/]+$/i.test(value); 
	},"field can only contain _0-9NXZ.*#/");	
	
	$.validator.addMethod("alpha",function(value,element) {
		return this.optional(element) || /^[A-Za-z0-9]{2,20}$/i.test(value); 
	},"field can only contain alphanumerics and no spaces");
		  
	$("#sarktrunkForm").validate ( {
	   rules: {
			transform: "xform",
			trunkname: "required alpha",
			tag: "alpha",
			match: {digits: true, 
						maxlength: 2},
			inprefix: {digits: true, 
						maxlength: 2},
			disapass: {range:[100,9999]},
			callerid: {digits:true},
/*			
 * 			didnumber: "required dialplan",
			host: "required",
			clinumber: "required dialplan"
*/								 			   
	   },
	   messages: {
//		   idname: "message"
	   }					
	});  


	$('#trunktable').dataTable ( {
//		"sScrollX": "100%",
		"bInfo": false,
		"bPaginate": true,
		"bLengthChange": false,
		"sDom": '<"top"i>pt<"bottom"f>',
		"aoColumnDefs": [ 
			{ "bSortable": false, "aTargets": [ 2,3,4,5,6,7,8,9,10 ] },
			{ "sClass": 'bluetags', "aTargets": [ 2,6,7 ] }
		],
		"aoColumns": [ 
			{ "sName": "pkey" },
			{ "sName": "cluster" },
			{ "sName": "trunkname" },
			{ "sName": "carriertype" },
			{ "sName": "ipaddr" },					
			{ "sName": "latency" },	
			{ "sName": "openroute" },		
			{ "sName": "closeroute" },	
			{ "sName": "connect"},
			{ "sName": "edit" },
			{ "sName": "del" }
		] 

	} ).makeEditable({
			sUpdateURL: "/php/sarktrunk/update.php",
//			sDeleteURL: "/php/sarktrunk/delete.php",
			sReadOnlyCellClass: "read_only",
			"aoColumns": [
				null,  	// pkey
				null,   // tenant
				{
					type: 'textarea',
                    onblur: 'cancel',
                    submit: 'Save',			
					tooltip: 'Double Click to set trunkname',
					onblur: 'cancel',
					placeholder: 'Null',
				}, 		// trunkname
				null,	// carriertype
				null,	// ipaddr
				null, 	// latency
				{
					type: 'select',
					tooltip: 'Double Click to select open route',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/endpoints/list.php',
        
                    loadtype: 'GET'					
				}, 	// open	
				{
					type: 'select',
					tooltip: 'Double Click to select closed route',
                    onblur: 'cancel',
                    submit: 'Save',
                    loadurl: '/php/endpoints/list.php',
                    loadtype: 'GET'					
				}, 	// closed	
				null, 	// connect	
				null,	// edit col	
				null	// delete col					
            ]
        }); 
/*
 * hide/reveal logic for trunk create
 */         
        $('#divtrunkname').hide();
        $('#divdidnumber').hide();
        $('#divdidend').hide();		
        $('#divclinumber').hide();
        $('#divusername').hide();
        $('#divpassword').hide();
        $('#divhost').hide();
        $('#divpeername').hide();
        $('#divregister').hide();
        $('#divprivileged').hide();
		$('#divsmartlink').hide();
		$('#divpredial').hide();
		$('#divpostdial').hide();
		$('#divrouteable').hide();
				
		$('#chooser').change(function(){
			$('#chooser').attr('disabled', true);
			$('#chooser').css('background-color','lightgrey');			
			if(this.value=='GeneralSIP' || this.value=='GeneralIAX2' ) {
				$('#divtrunkname').show();
				$('#divdidnumber').show();				
				$('#divusername').show();
				$('#divpassword').show();
				$('#divhost').show();
				$('#divregister').show();										
			}
			if(this.value=='InterSARK') {
				$('#divtrunkname').show();
				$('#divpeername').show();
				$('#divhost').show();
				$('#divpassword').show();
				$('#divpeername').show();
				$('#divprivileged').show();						
			}
			if(this.value=='Custom') {
				$('#divtrunkname').show();
				$('#divpredial').show();
				$('#divpostdial').show();
				$('#divrouteable').show();
			}	
			if(this.value=='DiD') {
				$('#divtrunkname').show();
				$('#divdidnumber').show();	
//				$('#divdidend').show();			
				$('#divsmartlink').show();
			}	
			if(this.value=='CLID') {
				$('#divtrunkname').show();
				$('#divclinumber').show();				
			}	
			$("#carrier").val($(this).val());			
					
		}); 
		
      });
      
