#!/bin/sh 

# *remobackup*.sh 
# Generates a 'backup' of sail configuration. 
# Report is sent by mail ( MAY CONTAIN PRIVATE/CONFIDENTIAL DATA ) 

# You can enable the script by adding some 'SAIL' custom application like : 
# ; script that sends config data of Mr Bean ... assuming script *remobackup*.sh into /etc/asterisk-scripts. 
# exten => *998*,x,System(/etc/asterisk-scripts/*remobackup*.sh) 

export EMAIL=admin@sip.aelintra.com

# config 
MAILADDRESS=jeffstokoe@gmail.com
SERVERNAME=`/sbin/e-smith/db configuration gettype SystemName` 
DOMAINNAME=`/sbin/e-smith/db configuration gettype DomainName` 
# end config 

# let's compress needed stuffs ... you can add what you want/need. 
/bin/tar -czf  /tmp/configuration.tgz /etc/asterisk/* 
/bin/tar -czf  /tmp/sark.db.tgz /opt/sark/db/sark.db 
/bin/tar -czf  /tmp/voicemail.tgz /var/spool/asterisk/voicemail

# Send everything via mail to the address specified in 'mailaddress' 
echo "Asterisk configuration files from "$SERVERNAME"@"$DOMAINNAME"  attached" | \
	mutt -s "Asterisk "$SERVERNAME"@"$DOMAINNAME" backup and config files" \
		-a /tmp/configuration.tgz \
		-a /tmp/sark.db.tgz \
		-a /tmp/voicemail.tgz \
		$MAILADDRESS 

# remove the temporary files 
rm /tmp/configuration.tgz 
rm /tmp/sark.db.tgz 
rm /tmp/voicemail.tgz

# end script

