#!/usr/bin/perl
#----------------------------------------------------------------------
# heading     : Telephony
# description : network set IP
#
#
# Copyright (c) aelintra.com         2011
#
#----------------------------------------------------------------------
#----------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Technical support for this program is available from Selintra Ltd
# Please visit our web site www.selintra.com/ for details.
#----------------------------------------------------------------------


use lib '/opt/sark/perl/modules';
use strict;
use sark::SarkSubs;

my $netaddress = SarkSubs::ret_subnet ();
my $cidr = SarkSubs::ret_cidr ();
my $msk = SarkSubs::ret_subnetmask ();

print "Setting local subnet as $netaddress/$cidr \n";
unless ( -e "/etc/e-smith" ) {
	`echo LAN=$netaddress/$cidr > /etc/shorewall/local.lan`;
}
`echo localnet=$netaddress/$msk > /etc/asterisk/sark_sip_localnet.conf`;

#
#  fix Asterisk missing include (maybe) 
#
unless  ( `grep 'include' /etc/asterisk/chan_dahdi.conf | grep 'dahdi-channels.conf'`) {
	`echo '#include dahdi-channels.conf' >>  /etc/asterisk/chan_dahdi.conf`;
}
#
#  fix Asterisk missing symlink (maybe) 
#
unless ( -e "/persistent" ) {
        unless ( -e "/var/lib/asterisk/sounds/en" ) {
                `ln -s /var/lib/asterisk/sounds/en-gb /var/lib/asterisk/sounds/en`;
        }
}

