#!/usr/bin/perl -w

{
use lib '/opt/sark/perl/modules';
use strict;
use sark::SarkSubs;
use Net::Domain qw(hostname hostfqdn hostdomain);

open STDIN, '/dev/null'   or die "Can't read /dev/null: $!";
open STDOUT, '>>/var/log/ha/synch-log' or die "SYNCHER102 ==> Can't write to log: $!";
open STDERR, '>>/var/log/ha/synch-error-log' or die "SYNCHER103 ==> Can't write to error log: $!";

my $t = localtime;
my $dbh = SarkSubs::SQLiteConnect();
my %global = SarkSubs::SQLiteGetHash($dbh, "SELECT * FROM globals WHERE pkey = 'global'");
SarkSubs::SQLiteDisconnect($dbh);
my $haprinode = $global{HAPRINODE};

unless ( $global{HASECNODE}  eq hostname() ) {
#	THIS IS NOT A SLAVE NODE, SHUT DOWN;
	exit (0);
}

unless ( SarkSubs::check_hapid ) {
#	print STDERR "$t SYNCHER101 ==> HA STOPPED - SHUTTING DOWN\n";
	exit (0);
}

unless  ( $global{HASYNCH} =~ /LAZY/ ) {
#	print STDERR "$t SYNCHER104 ==> HA doesn't specify sync\n";
	exit (0);
}

# flush the buffer
$| = 1;

unless ( -e "/mnt/db" ) {
	system "/bin/mkdir -p  /mnt/db";
}

while ( system ("/usr/bin/smbmount //$haprinode/syncshare /mnt/db -o username=,password=") ) {
	print STDERR "$t SYNCHER150 ==> Can't mount smb share at $haprinode - SHUTTING DOWN\n";
        exit (-1);
}

#print "\n$t mounted smb share at $haprinode\n";

unless ( -e "/mnt/db/sark.db" ) {
	print STDERR "$t SYNCHER101 ==> Couldn't mount primary share - ending";
        exit (-1);
}
# check for changes
unless (`/usr/bin/diff /mnt/db/sark.db /opt/sark/db/sark.db`) {
        exit (0);
}
elsif ( `/usr/bin/diff -a /mnt/db/sark.db /opt/sark/db/sark.db | /usr/bin/wc -l` == 4 ) {
        exit (0);
}

#copy it
if ( $global{HASYNCH} =~ /LAZY/ ) {
	if ( -e "/mnt/db/sark.db" ) {
		system ( "/bin/cp", "-f", "/mnt/db/sark.db", "/opt/sark/db" ) == 0
			or die "$t SYNCHER130 ==> Couldn't copy database";
		system ( "/bin/chmod", "660",  "/opt/sark/db/sark.db" ) == 0
			or die "$t SYNCHER131 ==> Couldn't chmod database";
		system ( "/bin sh", "/opt/sark/scripts/srkgenAst" ) == 0
			or die "$t SYNCHER132 ==> srkGEN failed";
		print "$t SYNCHER110 ==> LAZY UPDATE COMPLETED SUCCESSFULLY\n";
	}
        else {
		print STDERR "$t SYNCHER101 ==> CAN'T FIND PRIMARY SHARE!!!!\n";
	}
}

#clean up
system ( "/bin/umount", "//$haprinode/syncshare" ) == 0
       	or die "$t SYNCHER140 ==> UMOUNT failed";

#	print "$t SYNCHER199 ==> UNMOUNT COMPLETED SUCCESSFULLY\n";
exit (0);
}