<?php

include "commonFuncs.php";
include "settings.php";

global $haclusterip;
global $hausecluster;

$ua = $_SERVER["HTTP_USER_AGENT"];

$mac = strtolower($_GET['mac']);
//$type = $_GET['phone'];

$types = array('Snom 300'=>'snom300.htm',
	       'Snom 320'=>'snom320.htm',
	       'Snom 360'=>'snom360.htm',
	       'Snom 370'=>'snom370.htm',
	       'Snom 710'=>'snom710.htm',
	       'Snom 720'=>'snom720.htm',
	       'Snom 730'=>'snom760.htm',	       	       	       
	       'Snom 820'=>'snom820.htm',
	       'Snom 821'=>'snom821.htm',	       
	       'Snom 870'=>'snom870.htm');

if ($checkUA) {
  // check the user agent mac against url mac
  $macUA = getMacFromUA();
  if ($mac != $macUA) {
    logIt("Requested MAC: $mac does not match user agent MAC: $macUA.  Sending 404 and giving up");
    send404();
    exit;
  }
 }

// see if this mac exists, quit if not
try {
  $db = new PDO("sqlite:$dBFullPath");
} catch (PDOException $e) {
  die("Failed to get DB handle: " . $e->getMessage() . "\n");
  }

$macSearch = $db->prepare('select count(*) from IPphone where lower(macaddr) = ?');
$macSearch->execute(array($mac));

$rowCount = $macSearch->fetchColumn();
  
if ($rowCount == 1) {
  logIt("$mac found once so sending config");
 } elseif ($rowCount == 0) {
   logIt("$mac not found in db.  Sending 404 and giving up");
   send404();
   exit;
   } elseif ($rowCount > 1) {
     logIt("$mac found in db $rowCount times, not really sure what to do");
     exit("this mac found $rowCount times!");
     } elseif ($rowCount < 0) {
       logIt('Something has gone hideously wrong');
       die("What are you trying to do to me?");
       }

// if we are here then it's good to go
header('Content-type: text/plain');

try {	  
  	$global = $db->query("select * from globals")->fetch();
	$haclusterip = $global['HACLUSTERIP'];
//	echo "clusterip = $haclusterip\n\n";
	$hausecluster = $global['HAUSECLUSTER'];
//	echo "usecluster is $hausecluster \n\n";  
  // echo "Type is $type\n\n";
} catch (Exception $e) {
  logIt("Unable to retrieve cluster values");
  }	
  

try {
  $configs = $db->prepare('select pkey, provision,device,desc,passwd from IPphone where lower(macaddr) = ? limit 1');
  $configs->execute(array($mac));
  $thisConfig = $configs->fetchObject();
  $type = $types[$thisConfig->device];
  //echo "Type is $type\n\n";
} catch (Exception $e) {
  logIt("Unable send mac file for $mac");
  }

try {
  $descs = $db->prepare('select provision from Device where pkey like ? and technology = "Descriptor" limit 1');
  $descs->execute(array($type . "%"));
  $thisDesc = $descs->fetchObject();
} catch (Exception $e) {
  logIt("Unable get Descriptor file but will try to send mac file anyway.  mac is $mac");
  }

$rawConfig = $thisDesc->provision . "\n";
$rawConfig .= $thisConfig->provision . "\n";

$cleanConf =  cleanConfig($rawConfig, '/^([a-zA-Z0-9_]+)(\!|\$|\&)?:\s*(.*)$/',$thisConfig);
echo $cleanConf;

?>
